﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_03_DB_Bilder
Imports NM_Ahnen.cls_03_DB_Person_Neu
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_20_Blaettern
Imports NM_Ahnen.cls_91_DB_Para
Imports NM_Ahnen.NM_Ahnen_Search
Imports NM_Ahnen.NM_Ahnen_DB
Imports NM_Ahnen.NM_Ahnen_Info
Imports NM_Ahnen.NM_Ahnen_PersK


Class Cls_02_DB_Import_GM
    REM *************************************************************
    REM *  Importieren der GenMaster-Datei                          *
    REM *************************************************************
    Public Shared Sub Imp_GenMaster()

        REM Dateifolder für Auswahl der GenMaster-Datei GM3
        Call GM3_Auswahl()

        REM Öffnen der GM3-Datenbank mit Provider 4.0, Zieldatenbank in aktuelle DB
        Call Open_GM3()

        REM Übertragen der Datenfelder
        Call Transfer_Tabellen()
        conGM.Close()


    End Sub

    REM **************************************************************
    REM *  Dateiauswahl über OpenFileDialog                          *
    REM **************************************************************
    Public Shared Sub GM3_Auswahl()

        With NM_Ahnen
            .ofd_Pic.Filter = "GenMaster-DB|*.mdb"
            .ofd_Pic.InitialDirectory = str_LW_INI
            .ofd_Pic.Multiselect = False

            If .ofd_Pic.ShowDialog = DialogResult.OK Then
                myStream = .ofd_Pic.OpenFile
                str_PfadGM = .ofd_Pic.FileName
                str_FileGM = .ofd_Pic.FileName
                myStream.Close()
                str_LogFile = str_Directory + "/LogImpGM" + str_AktDat1 + ".txt"
                Using sw As StreamWriter = File.CreateText(str_LogFile)
                    sw.WriteLine("Import GenMaster")
                    sw.WriteLine("Startzeit: " + DateTime.Now)
                End Using
                .ofd_Pic.Dispose()
            Else
                Exit Sub
            End If
        End With

    End Sub

    REM **************************************************************
    REM *  Öffnen der ausgewählten GM3-Datenbank                     *
    REM **************************************************************
    Public Shared Sub Open_GM3()

        dbGM = "Provider=Microsoft.ACE.OLEDB.16.0; Data Source=" + str_PfadGM + "; Jet OLEDB:Database Password="
        conGM.ConnectionString = dbGM
        mySelectGM.Connection = conGM
        conGM.Open()


    End Sub

    REM **************************************************************
    REM *  Transfer starten                                          *
    REM **************************************************************
    Public Shared Sub Transfer_Tabellen()

        REM  Personendaten
        Call TransferPersNr()
        Call Trans_Personen()
        REM  Ehedaten
        Call Trans_Ehe()
        REM  Paten/Zeugen
        'Call Trans_Paten()
        'Call Trans_Zeugen()
        REM  Sonstiges
        Call Trans_Sonstiges()

    End Sub

    REM **********************************************************
    REM *  Lesen der Tabelle und speichern der Personennummer    *
    REM **********************************************************
    Public Shared Sub TransferPersNr()
        Dim reader As OleDbDataReader

        Dim GM_int_Max As Integer = GetNumberOfRecords(conGM, "fam")
        Dim GM_str_1 As String = "Anzahl Datensätze Quelle Person: " + GM_int_Max.ToString
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            sw.WriteLine(GM_str_1)
        End Using
        ReDim GM_str_NR(GM_int_Max)

        int_GM1 = 0
        int_Imp01 = 0
        int_Imp02 = 0
        int_Imp03 = 0
        int_Imp04 = 0
        int_Imp05 = 0
        int_Imp06 = 0
        int_Imp07 = 0
        int_Imp08 = 0
        int_Imp09 = 0
        int_Imp10 = 0
        int_Imp11 = 0
        int_Merk_Import = 1

        REM *  Masken umschalten
        NM_Ahnen.Enabled = False
        NM_Info.Visible = True

        With NM_Info
            .Text = "Import GenMaster"
            .lbl_Info00.Text = "Import gestartet - Datensätze: " & GM_int_Max.ToString
            .Show()
        End With

        mySelectGM.CommandText = "select * from fam"
        Try
            reader = mySelectGM.ExecuteReader

            Do While reader.Read
                myNull = IsDBNull(reader.Item(0))
                If myNull = False Then GM1_Nr = reader.Item(0).ToString
                GM_str_NR(int_GM1) = GM1_Nr
                int_GM1 += 1
            Loop
            reader.Close()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM ******************************************************************
    REM *  Read der einzelnen Datensätze auf Grund der Nummer            *
    REM ******************************************************************
    Public Shared Sub Trans_Personen()

        Dim reader As OleDbDataReader
        Dim int_GM3 As Integer = 0
        Dim GM1_NRx As String

        For int_GM3 = 0 To int_GM1
            GM_Nr = GM_str_NR(int_GM3)



            mySelectGM.CommandText = "select * from fam where nummer = '" & GM_str_NR(int_GM3) & "'"
            REM ***********************************************************
            REM *  Info-Fenster einblenden                                *
            REM ***********************************************************

            Try
                reader = mySelectGM.ExecuteReader
                Do While reader.Read
                    myNull = IsDBNull(reader.Item(0))
                    If myNull = False Then GM1_NRx = reader.Item(0).ToString
                    'If Val(GM1_NRx) <> 18 Then GoTo ST100

                    myNull = IsDBNull(reader.Item(1))
                    If myNull = False Then GM1_Name = reader.Item(1).ToString
                    myNull = IsDBNull(reader.Item(2))
                    If myNull = False Then GM1_Vorname = reader.Item(2).ToString
                    myNull = IsDBNull(reader.Item(3))
                    If myNull = False Then GM1_Titel = reader.Item(3).ToString
                    myNull = IsDBNull(reader.Item(4))
                    If myNull = False Then GM1_Vater = reader.Item(4).ToString
                    myNull = IsDBNull(reader.Item(5))
                    If myNull = False Then GM1_Mutter = reader.Item(5).ToString
                    myNull = IsDBNull(reader.Item(6))
                    If myNull = False Then GM1_Text = reader.Item(6).ToString
                    myNull = IsDBNull(reader.Item(7))
                    If myNull = False Then GM1_Geschlecht = reader.Item(7).ToString
                    myNull = IsDBNull(reader.Item(8))
                    If myNull = False Then GM1_GebTag = reader.Item(8).ToString
                    myNull = IsDBNull(reader.Item(9))
                    If myNull = False Then GM1_GebMonat = reader.Item(9).ToString
                    myNull = IsDBNull(reader.Item(10))
                    If myNull = False Then GM1_GebJahr = reader.Item(10).ToString
                    myNull = IsDBNull(reader.Item(11))
                    If myNull = False Then GM1_StTag = reader.Item(11).ToString
                    myNull = IsDBNull(reader.Item(12))
                    If myNull = False Then GM1_StMonat = reader.Item(12).ToString
                    myNull = IsDBNull(reader.Item(13))
                    If myNull = False Then GM1_StJahr = reader.Item(13).ToString
                    myNull = IsDBNull(reader.Item(14))
                    If myNull = False Then GM1_GebOrt = reader.Item(14).ToString
                    myNull = IsDBNull(reader.Item(15))
                    If myNull = False Then GM1_StOrt = reader.Item(15).ToString
                    myNull = IsDBNull(reader.Item(16))
                    If myNull = False Then GM1_Name2 = reader.Item(16).ToString
                    myNull = IsDBNull(reader.Item(17))
                    If myNull = False Then GM1_GebName = reader.Item(17).ToString
                    myNull = IsDBNull(reader.Item(18))
                    If myNull = False Then GM1_GNummer = reader.Item(18).ToString
                    myNull = IsDBNull(reader.Item(19))
                    If myNull = False Then GM1_SNummer = reader.Item(19).ToString
                    myNull = IsDBNull(reader.Item(20))
                    If myNull = False Then GM1_Konfess = reader.Item(20).ToString
                    myNull = IsDBNull(reader.Item(21))
                    If myNull = False Then GM1_TaufDat = reader.Item(21).ToString
                    myNull = IsDBNull(reader.Item(22))
                    If myNull = False Then GM1_TaufIn = reader.Item(22).ToString
                    myNull = IsDBNull(reader.Item(23))
                    If myNull = False Then GM1_TaufReg = reader.Item(23).ToString
                    myNull = IsDBNull(reader.Item(24))
                    If myNull = False Then GM1_TaufRegIn = reader.Item(24).ToString
                    myNull = IsDBNull(reader.Item(25))
                    If myNull = False Then GM1_KonfDat = reader.Item(25).ToString
                    myNull = IsDBNull(reader.Item(26))
                    If myNull = False Then GM1_Konfin = reader.Item(26).ToString
                    myNull = IsDBNull(reader.Item(27))
                    If myNull = False Then GM1_KonReg = reader.Item(27).ToString
                    myNull = IsDBNull(reader.Item(28))
                    If myNull = False Then GM1_KonRegin = reader.Item(28).ToString
                    myNull = IsDBNull(reader.Item(29))
                    If myNull = False Then GM1_GebRegIn = reader.Item(29).ToString
                    myNull = IsDBNull(reader.Item(30))
                    If myNull = False Then GM1_GesRegIn = reader.Item(30).ToString
                    myNull = IsDBNull(reader.Item(31))
                    If myNull = False Then GM1_BeerdDat = reader.Item(31).ToString
                    myNull = IsDBNull(reader.Item(32))
                    If myNull = False Then GM1_BeerdIn = reader.Item(32).ToString
                    myNull = IsDBNull(reader.Item(33))
                    If myNull = False Then GM1_GrabNr = reader.Item(33).ToString
                    myNull = IsDBNull(reader.Item(34))
                    If myNull = False Then GM1_GrabIn = reader.Item(34).ToString
                    myNull = IsDBNull(reader.Item(35))
                    If myNull = False Then GM1_Todesursache = reader.Item(35).ToString
                    myNull = IsDBNull(reader.Item(46))
                    If myNull = False Then GM1_AnlDat = reader.Item(46).ToString
                    myNull = IsDBNull(reader.Item(47))
                    If myNull = False Then GM1_AenDat = reader.Item(47).ToString

                    dbl_Max_ID = Val(GM_Nr)
                    p_int_ID = dbl_Max_ID

                    If GM1_BeerdDat = "________" Then GM1_BeerdDat = ""
                    If GM1_AenDat = "________" Then GM1_AenDat = ""
                    If GM1_KonfDat = "________" Then GM1_KonfDat = ""
                    If GM1_TaufDat = "________" Then GM1_TaufDat = ""

                    GM1_Name = LTrim(GM1_Name)
                    GM1_Name2 = LTrim(GM1_Name2)
                    GM1_GebName = LTrim(GM1_GebName)
                    GM1_Vorname = LTrim(GM1_Vorname)
                    GM1_AenDat = LTrim(GM1_AenDat)
                    GM1_AnlDat = LTrim(GM1_AnlDat)
                    GM1_BeerdDat = LTrim(GM1_BeerdDat)
                    GM1_BeerdIn = LTrim(GM1_BeerdIn)
                    GM1_GebTag = LTrim(GM1_GebTag)
                    GM1_GebMonat = LTrim(GM1_GebMonat)
                    GM1_GebJahr = LTrim(GM1_GebJahr)
                    GM1_GebOrt = LTrim(GM1_GebOrt)
                    GM1_GebRegIn = LTrim(GM1_GebRegIn)
                    GM1_Geschlecht = LTrim(GM1_Geschlecht)
                    GM1_GesRegIn = LTrim(GM1_GesRegIn)
                    GM1_GNummer = LTrim(GM1_GNummer)
                    GM1_GrabIn = LTrim(GM1_GrabIn)
                    GM1_GrabNr = LTrim(GM1_GrabNr)
                    GM1_KonfDat = LTrim(GM1_KonfDat)
                    GM1_Konfess = LTrim(GM1_Konfess)
                    GM1_Konfin = LTrim(GM1_Konfin)
                    GM1_KonReg = LTrim(GM1_KonReg)
                    GM1_KonRegin = LTrim(GM1_KonRegin)
                    GM1_SNummer = LTrim(GM1_SNummer)
                    GM1_StJahr = LTrim(GM1_StJahr)
                    GM1_StMonat = LTrim(GM1_StMonat)
                    GM1_StTag = LTrim(GM1_StTag)
                    GM1_StOrt = LTrim(GM1_StOrt)
                    GM1_TaufDat = LTrim(GM1_TaufDat)
                    GM1_TaufIn = LTrim(GM1_TaufIn)
                    GM1_TaufReg = LTrim(GM1_TaufReg)
                    GM1_TaufRegIn = LTrim(GM1_TaufRegIn)
                    GM1_Text = LTrim(GM1_Text)
                    GM1_Titel = LTrim(GM1_Titel)
                    GM1_Vater = Trim(GM1_Vater)
                    GM1_Mutter = Trim(GM1_Mutter)
                    GM1_Todesursache = LTrim(GM1_Todesursache)

                    GM1_Name = RTrim(GM1_Name)
                    GM1_Name2 = RTrim(GM1_Name2)
                    GM1_GebName = RTrim(GM1_GebName)
                    GM1_Vorname = RTrim(GM1_Vorname)
                    GM1_GebOrt = RTrim(GM1_GebOrt)
                    GM1_GebRegIn = RTrim(GM1_GebRegIn)
                    GM1_StOrt = RTrim(GM1_StOrt)
                    GM1_Text = RTrim(GM1_Text)
                    GM1_Titel = RTrim(GM1_Titel)
                    GM1_Todesursache = RTrim(GM1_Todesursache)
                    GM1_TaufReg = RTrim(GM1_TaufReg)
                    GM1_TaufRegIn = RTrim(GM1_TaufRegIn)
                    GM1_TaufIn = RTrim(GM1_TaufIn)
                    GM1_GesRegIn = RTrim(GM1_GesRegIn)
                    GM1_GNummer = RTrim(GM1_GNummer)
                    GM1_GrabIn = RTrim(GM1_GrabIn)
                    GM1_GrabNr = RTrim(GM1_GrabNr)
                    GM1_Konfin = RTrim(GM1_Konfin)
                    GM1_KonReg = RTrim(GM1_KonReg)
                    GM1_KonRegin = RTrim(GM1_KonRegin)
                    GM1_GebTag = RTrim(GM1_GebTag)
                    GM1_GebMonat = RTrim(GM1_GebMonat)
                    GM1_GebJahr = RTrim(GM1_GebJahr)
                    GM1_StJahr = RTrim(GM1_StJahr)
                    GM1_StMonat = RTrim(GM1_StMonat)
                    GM1_StTag = RTrim(GM1_StTag)

                    GM1_Name = DB_ZeichenString(GM1_Name)
                    GM1_GebName = DB_ZeichenString(GM1_GebName)
                    GM1_Vorname = DB_ZeichenString(GM1_Vorname)
                    GM1_Name2 = DB_ZeichenString(GM1_Name2)
                    GM1_GebOrt = DB_ZeichenString(GM1_GebOrt)
                    GM1_StOrt = DB_ZeichenString(GM1_StOrt)
                    GM1_Text = DB_ZeichenString(GM1_Text)
                    GM1_Todesursache = DB_ZeichenString(GM1_Todesursache)
                    GM1_Titel = DB_ZeichenString(GM1_Titel)

                    Call Trans_Neu()

                    With NM_Info
                        .lbl_Info01.Text = "Anzahl Datensätze Person"
                        .lbl_Info01Z.Text = int_Imp01.ToString

                        .lbl_Info02.Text = "Anzahl Datensätze Taufe"
                        .lbl_Info02Z.Text = int_Imp02.ToString

                        .lbl_Info03.Text = "Anzahl Datensätze Beerdigung"
                        .lbl_Info03Z.Text = int_Imp03.ToString

                        .lbl_Info04.Text = "Anzahl Datensätze Adresse"
                        .lbl_Info04Z.Text = int_Imp04.ToString

                        .lbl_Info05.Text = "Anzahl Datensätze Text"
                        .lbl_Info05Z.Text = int_Imp05.ToString

                        .lbl_Info06.Text = "Anzahl Datensätze Rolle"
                        .lbl_Info06Z.Text = int_Imp06.ToString

                        .lbl_Info07.Text = "Anzahl Datensätze Berufe"
                        .lbl_Info07Z.Text = int_Imp07.ToString

                        .lbl_Info08.Text = "Anzahl Datensätze Ehe"
                        .lbl_Info08Z.Text = int_Imp08.ToString

                        .lbl_Info09.Text = "Anzahl Datensätze Bilder"
                        .lbl_Info09Z.Text = int_Imp09.ToString

                        .lbl_Info10.Text = "Anzahl Info Pate"
                        .lbl_Info10Z.Text = int_Imp10.ToString

                        .lbl_Info11.Text = "Anzahl Info Trauzeuge"
                        .lbl_Info11Z.Text = int_Imp11.ToString

                        .Refresh()
                    End With

                Loop

ST100:
                reader.Close()

            Catch ex As Exception
                MsgBox(ex.Message)
            End Try


        Next int_GM3

        Call GM_famadr()
        Call GM_famdat()
        Call GM_famehe()
        Call GM_fabild()
        Call Trans_Paten()
        Call Trans_Zeugen()

        conGM.Close()
        con.Close()

        REM *  Logdatei füllen
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            GM_str_1 = "Anzahl Datensätze Person    : " + int_Imp01.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Taufe     : " + int_Imp02.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Beerdigung: " + int_Imp03.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Adresse   : " + int_Imp04.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Text      : " + int_Imp05.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Rolle     : " + int_Imp06.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Berufe    : " + int_Imp07.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Ehe       : " + int_Imp08.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Bilder    : " + int_Imp09.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Info Pate            : " + int_Imp10.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Info Trauzeuge       : " + int_Imp11.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Ende Import: " + DateTime.Now
            sw.WriteLine(GM_str_1)
        End Using

        NM_Info.Visible = False
        NM_Ahnen.Enabled = True
        NM_Ahnen.Visible = True
        NM_Ahnen.Show()

        REM *  Neustart mit neu angelegter Datenbank
        Call Load_INI()
        Call Open_DB()
        Call Open_Para()
        Call Grundwerte()
        Call Blaettern_First()


    End Sub

    Public Shared Sub Trans_Neu()

        Call Trans_Neu_t01()
        Call Trans_Neu_t02()
        Call Trans_Neu_t03()
        Call Trans_Neu_t05_Eltern()
        Call Trans_Neu_t12()

    End Sub

    Public Shared Sub Trans_Neu_t01()

        With NM_Ahnen
            .tx_10_Name.Text = GM1_Name
            .tx_10_NameZ.Text = GM1_Name2
            .tx_10_GebName.Text = GM1_GebName
            .tx_10_Vorname.Text = GM1_Vorname
            .tx_10_Titel.Text = GM1_Titel
            .tx_10_Vater.Text = GM1_Vater
            .tx_10_Mutter.Text = GM1_Mutter
            .tx_10_Geschl.Text = GM1_Geschlecht
            .tx_10_GDat_TT.Text = GM1_GebTag
            .tx_10_GDat_MM.Text = GM1_GebMonat
            .tx_10_GDat_JJ.Text = GM1_GebJahr
            int_GDat_Art = 1
            If GM1_GebTag = "<" Then int_GDat_Art = 2
            If GM1_GebTag = ">" Then int_GDat_Art = 3
            If GM1_GebTag = "<>" Then int_GDat_Art = 4
            If GM1_GebTag = "<" Or GM1_GebTag = ">" Or GM1_GebTag = "<>" Then GM1_GebTag = ""
            .tx_10_GOrt.Text = GM1_GebOrt


            .tx_10_SDat_TT.Text = GM1_StTag
            .tx_10_SDat_MM.Text = GM1_StMonat
            .tx_10_SDat_JJ.Text = GM1_StJahr
            int_SDat_Art = 1
            If GM1_StTag = "<" Then int_SDat_Art = 2
            If GM1_StTag = ">" Then int_SDat_Art = 3
            If GM1_StTag = "<>" Then int_SDat_Art = 4
            If GM1_StTag = "<" Or GM1_StTag = ">" Or GM1_StTag = "<>" Then GM1_GebTag = ""
            .tx_10_SOrt.Text = GM1_StOrt

            str_AktDat = GM1_AnlDat

        End With

        Call Person_Insert()
        int_Imp01 += 1
    End Sub

    Public Shared Sub Trans_Neu_t02()

        REM Prüfen auf Daten
        If GM1_TaufDat = "" And GM1_TaufIn = "" And GM1_KonfDat = "" And GM1_Konfin = "" And GM1_KonRegin = "" And GM1_Text = "" And GM1_TaufRegIn = "" Then
            Exit Sub
        End If
        If GM1_TaufDat = ".." Then Exit Sub

        With NM_Ahnen
            If GM1_Konfess = "" Then GM1_Konfess = "rk"
            .cbx_11_Konf.Text = GM1_Konfess
            .tx_11_TDat_TT.Text = Mid(GM1_TaufDat, 1, 2)
            .tx_11_TDat_MM.Text = Mid(GM1_TaufDat, 3, 2)
            .tx_11_TDat_JJ.Text = Mid(GM1_TaufDat, 5, 4)
            'If GM1_TaufIn <> "" Then Call Tauf_Ort()
            .tx_11_Tauf_Ort.Text = GM1_TaufIn
            .tx_11_Tauf_Kirche.Text = GM1_TaufKirche
            .tx_11_FDat_TT.Text = Mid(GM1_KonfDat, 1, 2)
            .tx_11_FDat_MM.Text = Mid(GM1_KonfDat, 3, 2)
            .tx_11_FDat_JJ.Text = Mid(GM1_KonfDat, 5, 4)
            .tx_11_FOrt.Text = GM1_Konfin
            .tx_11_FKirche.Text = GM1_KonRegin
            .rtx_11_Bemerk.Text = ""
        End With

        Call Person_Taufe_Insert()
        int_Imp02 += 1

    End Sub

    REM ************************************************************
    REM *  GM1_TaufIn trennen in Ort und Kirche                    *
    REM ************************************************************
    Public Shared Sub Tauf_Ort()
        Dim str_Tauf1 As String = ""
        Dim str_Tauf2 As String = ""
        Dim int_k1 As Integer = Len(GM1_TaufIn)
        Dim int_k2 As Integer = 0
        Dim int_k3 As Integer = 0

        If int_k1 < 2 Then Exit Sub
        For int_k2 = 1 To int_k1
            If Mid(GM1_TaufIn, int_k2, 1) = " " Then
                str_Tauf1 = Mid(GM1_TaufIn, 1, (int_k2 - 1))
                str_Tauf2 = Mid(GM1_TaufIn, int_k2 + 1, int_k1 - int_k2)
                Exit For
            Else
                If Mid(GM1_TaufIn, int_k2, 1) = "," Then
                    str_Tauf2 = Mid(GM1_TaufIn, 1, (int_k2 - 1))
                    str_Tauf1 = Mid(GM1_TaufIn, int_k2 + 1, int_k1 - int_k2)
                    Exit For
                Else
                    str_Tauf1 = GM1_TaufIn
                End If
            End If
        Next

        GM1_TaufIn = str_Tauf1
        GM1_TaufKirche = str_Tauf2
        If Mid(GM1_TaufKirche, 1, 1) = "(" Then Mid(GM1_TaufKirche, 1, 1) = " "
        If Mid(GM1_TaufKirche, 2, 1) = "(" Then Mid(GM1_TaufKirche, 2, 1) = " "
        'RTrim(GM1_TaufIn)
        'RTrim(GM1_TaufKirche)
        'LTrim(GM1_TaufIn)
        'LTrim(GM1_TaufKirche)
        Trim(GM1_TaufIn)
        Trim(GM1_TaufKirche)


        If GM1_TaufIn = "Harsewinkel" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Lucia"
        If GM1_TaufIn = "Beckum" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Stephanus"
        If GM1_TaufIn = "Wadersloh" Or GM1_TaufIn = "Ostenfelde" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Margaretha"
        If GM1_TaufIn = "Walstedde" Or GM1_TaufIn = "Dolberg" Or GM1_TaufIn = "Stromberg" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Lambertus"
        If GM1_TaufIn = "Diestedde" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Nikolaus"
        If GM1_TaufIn = "Freckenhorst" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Bonifatius"
        If GM1_TaufIn = "Sendenhorst" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Martin"
        If GM1_TaufIn = "Vorhelm" Or GM1_TaufIn = "Vellern" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Pankratius"
        If GM1_TaufIn = "Lippborg" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Cornelius"
        If GM1_TaufIn = "Ennigerloh" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Jakobus"
        If GM1_TaufIn = "Lüdinghausen" And GM1_TaufKirche = "" Then GM1_TaufKirche = "St. Felizitas"
        If GM1_TaufKirche = "Marien Ahlen" And GM1_TaufIn = "" Then
            GM1_TaufIn = "Ahlen"
            GM1_TaufKirche = "St. Marien"
        End If
        If GM1_TaufKirche = "Bartholomäus Ahl" And GM1_TaufIn = "" Then
            GM1_TaufIn = "Ahlen"
            GM1_TaufKirche = "St. Bartholomäus"
        End If

    End Sub

    Public Shared Sub Trans_Neu_t03()

        REM Prüfen auf Daten
        If GM1_BeerdDat = "" And GM1_BeerdIn = "" And GM1_GrabIn = "" And GM1_GrabNr = "" And GM1_Todesursache = "" Then
            Exit Sub
        End If

        With NM_Ahnen
            .tx_12_BDat_TT.Text = Mid(GM1_BeerdDat, 1, 2)
            .tx_12_BDat_MM.Text = Mid(GM1_BeerdDat, 3, 2)
            .tx_12_BDat_JJ.Text = Mid(GM1_BeerdDat, 5, 4)
            .tx_12_B_Ort.Text = GM1_BeerdIn
            .tx_12_Friedhof.Text = GM1_GrabIn
            .tx_12_Grablage.Text = ""
            .tx_12_Tod_Ursache.Text = GM1_Todesursache
            .tx_12_Priester.Text = ""
            .rtx_12_Bemerk.Text = ""
        End With

        Call Person_Beerd_Insert()
        int_Imp03 += 1

    End Sub

    Public Shared Sub Trans_Neu_t05_Eltern()
        p_int_ID = GM_Nr
        dbl_Vater = GM1_Vater
        dbl_Mutter = GM1_Mutter
        Call Person_Eltern_Neu()
        If GM1_Vater > "0" Then int_Imp06 += 1
        If GM1_Mutter > "0" Then int_Imp06 += 1
    End Sub

    Public Shared Sub Trans_Neu_t12()

        If GM1_Text = "" Then
            Exit Sub
        End If

        With NM_Ahnen
            .rtx_16_1.Text = GM1_Text
            Call Person_Text_Insert()
            int_Imp05 += 1
        End With

    End Sub

    Public Shared Sub Trans_Ehe()

    End Sub

    Public Shared Sub Trans_Paten()

        Dim reader As OleDbDataReader
        Dim int_GM3 As Integer
        Dim GM_dbl_Nr As Double = 0
        GM5_TabIndex = 1
        Dim GM_where As String = ""
        Dim GM_Ber_Max = GetNumberOfRecordsTyp(conGM, "famdat", " where ART LIKE '%1%'")
        'Dim GM_Ber_Max As Integer = GetNumberOfRecords(conGM, "famdat")
        Dim GM_str_1 As String = "Anzahl Datensätze Quelle Pate: " + GM_Ber_Max.ToString
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            sw.WriteLine(GM_str_1)
        End Using

        GM_dbl_Nr = p_int_ID
        For int_GM3 = 0 To int_GM1
            GM_Nr = GM_str_NR(int_GM3)
            p_int_ID = Val(GM_Nr)
            dbl_Max_ID = Val(GM_Nr)
            GM_where = " where NUMMER = '" + GM_Nr + "' and ART LIKE '%1%'"
            mySelectGM.CommandText = "Select * from famdat" & GM_where
            GM5_Text = ""
            Try
                reader = mySelectGM.ExecuteReader
                Do While reader.Read
                    myNull = IsDBNull(reader.Item(4))
                    If myNull = False Then
                        If GM5_Text <> "" Then GM5_Text += ", "
                        If GM5_Text = "" Then GM5_Text = "Taufpaten: "
                        GM5_Text += reader.Item(4)
1:                  End If
                Loop
                reader.Close()

            Catch ex As Exception

            End Try

            If GM5_Text > "" Then
                dbl_ID = dbl_Max_ID
                str_UString = "t02_Bemerk = '" + GM5_Text + "'"
                Call Person_Update_T02()
                int_Imp10 += 1

                dbl_Pers_ID = dbl_ID
                With NM_Ahnen_PersK
                    .tx_301_Name.Text = GM5_Text
                    .tx_301_GebName.Text = ""
                    .tx_301_Vorname.Text = ""
                    .tx_301_GDat_TT.Text = ""
                    .tx_301_GDat_MM.Text = ""
                    .tx_301_GDat_JJ.Text = ""
                End With
                str_Aufgabe = "Anlage Paten"
                int_NM_FeldNr = 35
                Call Person_Aufgabe_Insert()
            End If
            NM_Info.lbl_Info10.Text = "Anzahl Info Paten"
            NM_Info.lbl_Info10Z.Text = int_Imp10.ToString
            NM_Info.Refresh()

        Next

    End Sub

    Public Shared Sub Trans_Zeugen()

        Dim reader As OleDbDataReader
        Dim int_GM3 As Integer
        Dim GM_dbl_Nr As Double = 0
        Dim GM_where As String = ""
        Dim GM_Partner As String = ""
        Dim GM_P2 As Double = 0
        Dim GM_41 As Double = 0
        GM5_TabIndex = 3
        Dim GM_Ber_Max = GetNumberOfRecordsTyp(conGM, "famdat", " where ART LIKE '%4%'")
        'Dim GM_Ber_Max As Integer = GetNumberOfRecords(conGM, "famdat")
        Dim GM_str_1 As String = "Anzahl Datensätze Quelle Trauzeuge: " + GM_Ber_Max.ToString
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            sw.WriteLine(GM_str_1)
        End Using

        GM_dbl_Nr = p_int_ID
        For int_GM3 = 0 To int_GM1
            GM_Nr = GM_str_NR(int_GM3)
            p_int_ID = Val(GM_Nr)
            dbl_Max_ID = Val(GM_Nr)
            GM_where = " where NUMMER = '" + GM_Nr + "' and ART LIKE '%4%'"
            mySelectGM.CommandText = "Select * from famdat" & GM_where
            GM5_Text = ""
            Try
                reader = mySelectGM.ExecuteReader
                Do While reader.Read
                    myNull = IsDBNull(reader.Item(2))
                    If myNull = False Then GM_Partner = reader.Item(2)
                    myNull = IsDBNull(reader.Item(4))
                    If myNull = False Then GM5_Text = reader.Item(4)
                Loop
                reader.Close()

            Catch ex As Exception

            End Try

            If GM5_Text > "" Then
                GM_P2 = Val(GM_Partner)
                GM_where = " where t04_Partner1 = " + dbl_Max_ID.ToString + " and t04_Partner2 = " + GM_P2.ToString
                mySelect.CommandText = "select * from t04_Ehe" + GM_where
                Try
                    reader = mySelect.ExecuteReader
                    Do While reader.Read
                        myNull = IsDBNull(reader.Item("t04_FK_ID"))
                        If myNull = False Then GM_41 = reader.Item("t04_FK_ID")
                    Loop
                    reader.Close()
                Catch ex As Exception

                End Try

                dbl_ID = GM_41
                str_UString = "t041_Bemerkung = '" + GM5_Text + "'"
                Call Person_Update_T041()
                int_Imp11 += 1
                dbl_Pers_ID = dbl_ID
                With NM_Ahnen_PersK
                    .tx_301_Name.Text = GM5_Text
                    .tx_301_GebName.Text = ""
                    .tx_301_Vorname.Text = ""
                    .tx_301_GDat_TT.Text = ""
                    .tx_301_GDat_MM.Text = ""
                    .tx_301_GDat_JJ.Text = ""
                End With
                str_Aufgabe = "Anlage Trauzeugen"
                int_NM_FeldNr = 45
                Call Person_Aufgabe_Insert()
            End If
            NM_Info.lbl_Info11.Text = "Anzahl Info Trauzeugen"
            NM_Info.lbl_Info11Z.Text = int_Imp11.ToString
            NM_Info.Refresh()

        Next

    End Sub

    Public Shared Sub Trans_Sonstiges()

    End Sub

    REM **************************************************************
    REM *  Prüfen File auf Vorhandensein                             *
    REM **************************************************************
    Public Shared Sub GM_Exists()

        Dim i11 As Integer
        Dim i12 As Integer

        If File.Exists(str_PfadGM) Then
            i11 = Len(str_FileGM)
            For i12 = i11 To 0 Step -1
                If Mid(str_FileGM, i12, 1) = "." Then
                    str_DateiEndung = Mid(str_FileName, i12 + 1, i11 - i12)
                    str_FileName = Mid(str_FileName, 1, i12 - 1)
                    If int_Merk_Bild = 1 Then
                        Exit Sub
                    End If
                End If
            Next
        End If

    End Sub

    REM **************************************************************
    REM *  Ermitteln des Pfades der Bilddatei                        *
    REM **************************************************************
    Public Shared Sub Pfad_GM()

        Dim i11 As Integer
        Dim i12 As Integer

        i11 = Len(str_PfadGM)
        For i12 = i11 To 0 Step -1
            If Mid(str_PfadGM, i12, 1) = "\" Then
                str_FileName = Mid(str_Path_1, i12 + 1, i11 - i12)
                str_Path_2 = str_Directory + "/Pic/" + str_FileName
                i12 = 0
            End If
        Next

    End Sub

    REM ****************************************************************
    REM *  Dazulesen weiterer Tabellen                                 *
    REM ****************************************************************
    Public Shared Sub GM_famadr()
        Dim reader As OleDbDataReader
        Dim int_GM3 As Integer
        Dim GM_where As String
        Dim GM_Adr_Max As Integer = GetNumberOfRecords(conGM, "famadr")

        Dim GM_str_1 As String = "Anzahl Datensätze Quelle Adressen: " + GM_Adr_Max.ToString
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            sw.WriteLine(GM_str_1)
        End Using

        For int_GM3 = 0 To int_GM1
            GM_Nr = GM_str_NR(int_GM3)
            p_int_ID = Val(GM_Nr)
            dbl_Max_ID = Val(GM_Nr)
            GM_where = " where NUMMER = '" + GM_Nr + "'"
            mySelectGM.CommandText = "Select * from famadr" & GM_where

            Try
                reader = mySelectGM.ExecuteReader
                Do While reader.Read
                    myNull = IsDBNull(reader.Item(1))
                    If myNull = False Then GM4_Land = reader.Item(1)
                    myNull = IsDBNull(reader.Item(2))
                    If myNull = False Then GM4_PLZ = reader.Item(2)
                    myNull = IsDBNull(reader.Item(3))
                    If myNull = False Then GM4_Ort = reader.Item(3)
                    myNull = IsDBNull(reader.Item(4))
                    If myNull = False Then GM4_Strasse = reader.Item(4)
                    myNull = IsDBNull(reader.Item(5))
                    If myNull = False Then GM4_Tel1 = reader.Item(5)
                    myNull = IsDBNull(reader.Item(6))
                    If myNull = False Then GM4_Tel2 = reader.Item(6)
                    myNull = IsDBNull(reader.Item(7))
                    If myNull = False Then GM4_von = reader.Item(7)
                    myNull = IsDBNull(reader.Item(8))
                    If myNull = False Then GM4_bis = reader.Item(8)
                    myNull = IsDBNull(reader.Item(10))
                    If myNull = False Then GM4_Fax = reader.Item(10)
                    myNull = IsDBNull(reader.Item(11))
                    If myNull = False Then GM4_Mail = reader.Item(11)

                    If GM4_von = "________" Then GM4_von = ""
                    If GM4_bis = "________" Then GM4_bis = ""
                    Call Trans_Neu_t06()
                Loop
                reader.Close()
            Catch ex As Exception

            End Try
        Next

    End Sub

    Public Shared Sub Trans_Neu_t06()

        REM Prüfen auf Daten
        If GM4_bis = "" And GM4_von = "" And GM4_Land = "" And GM4_PLZ = "" And GM4_Strasse = "" Then
            Exit Sub
        End If

        With NM_Ahnen
            .tx_14_Land.Text = GM4_Land
            .tx_14_PLZ.Text = GM4_PLZ
            .tx_14_Strasse.Text = GM4_Strasse
            .tx_14_Ort.Text = GM4_Ort
            .tx_14_Dat1_TT.Text = Mid(GM4_von, 1, 2)
            .tx_14_Dat1_MM.Text = Mid(GM4_von, 3, 2)
            .tx_14_Dat1_JJ.Text = Mid(GM4_von, 5, 4)
            .tx_14_Dat2_TT.Text = Mid(GM4_bis, 1, 2)
            .tx_14_Dat2_MM.Text = Mid(GM4_bis, 3, 2)
            .tx_14_Dat2_JJ.Text = Mid(GM4_bis, 5, 4)
            .rtx_12_Bemerk.Text = ""
        End With

        Call Person_Adresse_Insert()
        int_Imp04 += 1

        NM_Info.lbl_Info04.Text = "Anzahl Datensätze Adresse"
        NM_Info.lbl_Info04Z.Text = int_Imp04.ToString
        NM_Info.Refresh()

    End Sub

    REM ****************************************************************
    REM *  Dazulesen weiterer Tabellen (Berufe)                        *
    REM ****************************************************************
    Public Shared Sub GM_famdat()
        Dim reader As OleDbDataReader
        Dim int_GM3 As Integer
        Dim GM_where As String
        Dim GM_Ber_Max = GetNumberOfRecordsTyp(conGM, "famdat", " where ART LIKE '%2%'")
        'Dim GM_Ber_Max As Integer = GetNumberOfRecords(conGM, "famdat")
        Dim GM_str_1 As String = "Anzahl Datensätze Quelle Beruf: " + GM_Ber_Max.ToString
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            sw.WriteLine(GM_str_1)
        End Using

        For int_GM3 = 0 To int_GM1
            GM_Nr = GM_str_NR(int_GM3)
            p_int_ID = Val(GM_Nr)
            dbl_Max_ID = Val(GM_Nr)
            GM_where = " where NUMMER = '" + GM_Nr + "' and ART LIKE '%2%'"
            mySelectGM.CommandText = "Select * from famdat" & GM_where

            Try
                reader = mySelectGM.ExecuteReader
                Do While reader.Read
                    myNull = IsDBNull(reader.Item(4))
                    If myNull = False Then GM5_Text = reader.Item(4)
                    Call Trans_Neu_t07()
                Loop
                reader.Close()
            Catch ex As Exception

            End Try
        Next

    End Sub

    Public Shared Sub Trans_Neu_t07()

        REM Prüfen auf Daten
        If GM5_Text > "" Then
            With NM_Ahnen
                .tx_15_Beruf.Text = GM5_Text
            End With
            Call Person_Beruf_Insert()
            int_Imp07 += 1

            NM_Info.lbl_Info07.Text = "Anzahl Datensätze Berufe"
            NM_Info.lbl_Info07Z.Text = int_Imp07.ToString
            NM_Info.Refresh()
        End If

    End Sub

    REM ******************************************************************
    REM *  Ehedaten übernehmen                                           *
    REM ******************************************************************
    Public Shared Sub GM_famehe()

        Dim reader As OleDbDataReader
        Dim GM_Ehe_Max As Integer = GetNumberOfRecords(conGM, "fame")
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            GM_str_1 = "Anzahl Datensätze Quelle Ehe: " + GM_Ehe_Max.ToString
            sw.WriteLine(GM_str_1)
        End Using

        mySelectGM.CommandText = "select * from fame"
        Try
            reader = mySelectGM.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item(0))
                If myNull = False Then GM6_ID1 = reader.Item(0)
                myNull = IsDBNull(reader.Item(1))
                If myNull = False Then GM6_ID2 = reader.Item(1)
                myNull = IsDBNull(reader.Item(2))
                If myNull = False Then GM6_Text = reader.Item(2)
                myNull = IsDBNull(reader.Item(3))
                If myNull = False Then GM6_KDat_TT = reader.Item(3)
                myNull = IsDBNull(reader.Item(4))
                If myNull = False Then GM6_KDat_MM = reader.Item(4)
                myNull = IsDBNull(reader.Item(5))
                If myNull = False Then GM6_KDat_JJ = reader.Item(5)
                myNull = IsDBNull(reader.Item(6))
                If myNull = False Then GM6_K_Ort = reader.Item(6)
                myNull = IsDBNull(reader.Item(7))
                If myNull = False Then GM6_K_Priester = reader.Item(7)
                myNull = IsDBNull(reader.Item(8))
                If myNull = False Then GM6_SDat_TT = reader.Item(8)
                myNull = IsDBNull(reader.Item(9))
                If myNull = False Then GM6_SDat_MM = reader.Item(9)
                myNull = IsDBNull(reader.Item(10))
                If myNull = False Then GM6_SDat_JJ = reader.Item(10)
                myNull = IsDBNull(reader.Item(11))
                If myNull = False Then GM6_S_Ort = reader.Item(11)
                myNull = IsDBNull(reader.Item(12))
                If myNull = False Then GM6_S_Beamter = reader.Item(12)
                myNull = IsDBNull(reader.Item(13))
                If myNull = False Then GM6_KEnde_TT = reader.Item(13)
                myNull = IsDBNull(reader.Item(14))
                If myNull = False Then GM6_KEnde_MM = reader.Item(14)
                myNull = IsDBNull(reader.Item(15))
                If myNull = False Then GM6_KEnde_JJ = reader.Item(15)
                myNull = IsDBNull(reader.Item(16))
                If myNull = False Then GM6_SEnde_TT = reader.Item(16)
                myNull = IsDBNull(reader.Item(17))
                If myNull = False Then GM6_SEnde_MM = reader.Item(17)
                myNull = IsDBNull(reader.Item(18))
                If myNull = False Then GM6_SEnde_JJ = reader.Item(18)
                myNull = IsDBNull(reader.Item(19))
                If myNull = False Then GM6_K_Urk = reader.Item(19)
                myNull = IsDBNull(reader.Item(20))
                If myNull = False Then GM6_S_Urk = reader.Item(20)
                myNull = IsDBNull(reader.Item(21))
                If myNull = False Then GM6_KEnde_Urk = reader.Item(21)
                myNull = IsDBNull(reader.Item(22))
                If myNull = False Then GM6_SEnde_Urk = reader.Item(22)
                myNull = IsDBNull(reader.Item(23))
                If myNull = False Then GM6_VDat = reader.Item(23)
                myNull = IsDBNull(reader.Item(24))
                If myNull = False Then GM6_VOrt = reader.Item(24)
                myNull = IsDBNull(reader.Item(26))
                If myNull = False Then GM6_Kirche = reader.Item(26)

                GM6_KDat_JJ = Trim(GM6_KDat_JJ)
                GM6_KDat_MM = Trim(GM6_KDat_MM)
                GM6_KDat_TT = Trim(GM6_KDat_TT)
                GM6_SDat_JJ = Trim(GM6_SDat_JJ)
                GM6_SDat_MM = Trim(GM6_SDat_MM)
                GM6_SDat_TT = Trim(GM6_SDat_TT)
                GM6_SEnde_JJ = Trim(GM6_SEnde_JJ)
                GM6_SEnde_MM = Trim(GM6_SEnde_MM)
                GM6_SEnde_TT = Trim(GM6_SEnde_TT)
                If GM6_KDat_JJ = "____" Then GM6_KDat_JJ = ""
                If GM6_KDat_MM = "____" Then GM6_KDat_MM = ""
                If GM6_KDat_TT = "____" Then GM6_KDat_TT = ""
                If GM6_SDat_JJ = "____" Then GM6_SDat_JJ = ""
                If GM6_SDat_MM = "____" Then GM6_SDat_MM = ""
                If GM6_SDat_TT = "____" Then GM6_SDat_TT = ""
                If GM6_SEnde_JJ = "____" Then GM6_SEnde_JJ = ""
                If GM6_SEnde_MM = "____" Then GM6_SEnde_MM = ""
                If GM6_SEnde_TT = "____" Then GM6_SEnde_TT = ""

                GM6_K_Ort = LTrim(GM6_K_Ort)
                GM6_K_Priester = LTrim(GM6_K_Priester)
                GM6_K_Urk = LTrim(GM6_K_Urk)
                GM6_KEnde_Urk = LTrim(GM6_KEnde_Urk)
                GM6_Kirche = LTrim(GM6_Kirche)
                GM6_S_Beamter = LTrim(GM6_S_Beamter)
                GM6_S_Ort = LTrim(GM6_S_Ort)
                GM6_S_Urk = LTrim(GM6_S_Urk)
                GM6_Text = LTrim(GM6_Text)
                GM6_SEnde_Urk = LTrim(GM6_SEnde_Urk)
                GM6_VOrt = LTrim(GM6_VOrt)

                GM6_K_Ort = DB_ZeichenString(GM6_K_Ort)
                GM6_K_Priester = DB_ZeichenString(GM6_K_Priester)
                GM6_K_Urk = DB_ZeichenString(GM6_K_Urk)
                GM6_KEnde_Urk = DB_ZeichenString(GM6_KEnde_Urk)
                GM6_Kirche = DB_ZeichenString(GM6_Kirche)
                GM6_S_Beamter = DB_ZeichenString(GM6_S_Beamter)
                GM6_S_Ort = DB_ZeichenString(GM6_S_Ort)
                GM6_S_Urk = DB_ZeichenString(GM6_S_Urk)
                GM6_Text = DB_ZeichenString(GM6_Text)
                GM6_SEnde_Urk = DB_ZeichenString(GM6_SEnde_Urk)

                Call Trans_Neu_t041()

            Loop
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Public Shared Sub Trans_Neu_t041()

        dbl_ID = Val(GM6_ID1)
        dbl_Sel_ID = Val(GM6_ID2)

        With NM_Ahnen
            .tx_13_Dat1_TT.Text = GM6_SDat_TT
            .tx_13_Dat1_MM.Text = GM6_SDat_MM
            .tx_13_Dat1_JJ.Text = GM6_SDat_JJ
            'int_EDat1_Art = 1
            .tx_13_Ort1.Text = GM6_S_Ort
            .tx_13_Beamter.Text = GM6_S_Beamter
            .tx_13_Dat2_TT.Text = GM6_KDat_TT
            .tx_13_Dat2_MM.Text = GM6_KDat_MM
            .tx_13_Dat2_JJ.Text = GM6_KDat_JJ
            'int_EDat2_Art = 1
            .tx_13_Ort2.Text = GM6_K_Ort
            .tx_13_Kirche.Text = GM6_Kirche
            .tx_13_Priester.Text = GM6_K_Priester
            .tx_13_Dat3_TT.Text = GM6_SEnde_TT
            .tx_13_Dat3_MM.Text = GM6_SEnde_MM
            .tx_13_Dat3_JJ.Text = GM6_SEnde_JJ
            'int_EDat3_Art = 1
            .rtx_13_Bemerk.Text = GM6_Text

            Call Person_Ehe_041()
            int_Imp08 += 1

        End With

        NM_Info.lbl_Info08.Text = "Anzahl Datensätze Ehe"
        NM_Info.lbl_Info08Z.Text = int_Imp08.ToString
        NM_Info.Refresh()

    End Sub

    Public Shared Sub GM_fabild()

        Dim reader As OleDbDataReader
        Dim i11 As Integer
        Dim i12 As Integer
        Dim GM_Pic_Max As Integer = GetNumberOfRecords(conGM, "fabild")
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            GM_str_1 = "Anzahl Datensätze Quelle Pic/Dok: " + GM_Pic_Max.ToString
            sw.WriteLine(GM_str_1)
        End Using

        mySelectGM.CommandText = "select * from fabild"
        Try
            reader = mySelectGM.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item(0))
                If myNull = False Then GM6_ID1 = reader.Item(0)
                myNull = IsDBNull(reader.Item(2))
                If myNull = False Then GM6_K_Priester = reader.Item(2)
                myNull = IsDBNull(reader.Item(3))
                If myNull = False Then GM6_K_Ort = reader.Item(3)

                str_FileName = ""
                i11 = Len(GM6_K_Priester)
                For i12 = i11 To 0 Step -1
                    If Mid(GM6_K_Priester, i12, 1) = "\" Then
                        str_FileName = Mid(GM6_K_Priester, i12 + 1, i11 - i12)
                        i12 = 0
                    End If
                Next

                If File.Exists(GM6_K_Priester) Then
                    Call Trans_Neu_t09()
                Else
                    Using sw As StreamWriter = File.AppendText(str_LogFile)
                        GM_str_1 = "Bild-Datei nicht vorhanden: " + GM6_K_Priester.ToString
                        sw.WriteLine(GM_str_1)
                    End Using

                End If

            Loop
            reader.Close()
            Using sw As StreamWriter = File.AppendText(str_LogFile)
                GM_str_1 = "Bild-übernommen: " + int_Imp09.ToString
                sw.WriteLine(GM_str_1)
            End Using

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM ************************************************************
    REM *  Bildtabelle t09 inserten                                *
    REM ************************************************************
    Public Shared Sub Trans_Neu_t09()

        dbl_ID = Val(GM6_ID1)
        NM_Ahnen.tx_01_Bez.Text = GM6_K_Ort
        Call Bild_Insert()
        int_Imp09 += 1

        With NM_Ahnen
            FileCopy(GM6_K_Priester, str_PicDirectory + str_FileName)
        End With
        NM_Info.lbl_Info09.Text = "Anzahl Datensätze Bilder"
        NM_Info.lbl_Info09Z.Text = int_Imp09.ToString
        NM_Info.Refresh()

    End Sub

    Public Shared Sub Trans_Update_t02()

        dbl_ID = Val(GM6_ID1)
        str_UString += "t02_Bemerk = '" + GM5_Text + ""

        Call Person_Update_T02()

    End Sub

End Class