﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_03_DB_Bilder
Imports NM_Ahnen.cls_03_DB_Person_Neu
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_20_Blaettern
Imports NM_Ahnen.cls_91_DB_Para
Imports NM_Ahnen.NM_Ahnen_Search
Imports NM_Ahnen.NM_Ahnen_DB
Imports NM_Ahnen.NM_Ahnen_Info
Imports NM_Ahnen.NM_Ahnen_PersK


Class Cls_02_DB_Import_GedCom
    REM *************************************************************
    REM *  Importieren der GenMaster-Datei                          *
    REM *************************************************************
    Public Shared Sub Imp_GedCom()

        REM Dateifolder für Auswahl der GedComDatei
        Call GedCom_Auswahl()

        REM Öffnen der GM3-Datenbank mit Provider 4.0, Zieldatenbank in aktuelle DB
        Call Open_GedCom()

        REM Übertragen der Datenfelder
        Call Transfer_Tabellen()

    End Sub

    REM **************************************************************
    REM *  Dateiauswahl über OpenFileDialog                          *
    REM **************************************************************
    Public Shared Sub GedCom_Auswahl()

        With NM_Ahnen
            .ofd_Pic.Filter = "Gedcom-Dateien|*.ged"
            .ofd_Pic.InitialDirectory = str_LW_INI
            .ofd_Pic.Multiselect = False

            If .ofd_Pic.ShowDialog = DialogResult.OK Then
                myStream = .ofd_Pic.OpenFile
                str_PfadGed = .ofd_Pic.FileName
                str_FileGed = .ofd_Pic.FileName
                myStream.Close()
                str_LogFile = str_Directory + "/LogImpGed" + str_AktDat1 + ".txt"
                Using sw As StreamWriter = File.CreateText(str_LogFile)
                    sw.WriteLine("Import GedCom")
                    sw.WriteLine("Startzeit: " + DateTime.Now)
                End Using
                .ofd_Pic.Dispose()
            Else
                Exit Sub
            End If
        End With

    End Sub

    REM **************************************************************
    REM *  Öffnen der ausgewählten Ged-Datei                         *
    REM **************************************************************
    Public Shared Sub Open_GedCom()

        Dim fs As FileStream
        Dim ft As FileStream
        int_GedFound = 0
        int_GedAnz = 0
        int_Ged_Tab = 0
        Dim i1 As Integer
        Dim i2 As Integer
        Try
            fs = New FileStream(str_PfadGed, FileMode.Open)
        Catch ex As IOException
            MsgBox(ex.Message)
            int_Total_Error = 1
            Exit Sub
        End Try

        Dim sw As New StreamReader(fs)
        Dim str_N01 As String

        REM *------------------------------------------------------*
        REM *  Ermitteln Datensätze der GedCom-Datei               *
        REM *------------------------------------------------------*
        Try
            Do Until sw.Peek() = -1
                str_Ged = sw.ReadLine()
                int_GedFound += 1
                str_N01 = Mid(str_Ged, 1, 1)
                If str_N01 = "0" Then
                    Call GedCom_Anz()
                End If
            Loop
            sw.Close()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        ReDim Ged_ID(int_GedAnz)
        ReDim Ged_Name(int_GedAnz)
        ReDim Ged_Geschlecht(int_GedAnz)
        ReDim Ged_Beruf(int_GedAnz)
        ReDim Ged_GebDatum(int_GedAnz)
        ReDim Ged_Adresse(int_GedAnz)
        ReDim Ged_Religion(int_GedAnz)
        ReDim Ged_BeerdDatum(int_GedAnz)
        ReDim Ged_TaufDatum(int_GedAnz)
        ReDim Ged_StDatum(int_GedAnz)
        ReDim Ged_TaufOrt(int_GedAnz)
        ReDim Ged_BeerdOrt(int_GedAnz)
        ReDim Ged_GebOrt(int_GedAnz)
        ReDim Ged_StOrt(int_GedAnz)

        Try
            ft = New FileStream(str_PfadGed, FileMode.Open)
        Catch ex As IOException
            MsgBox(ex.Message)
            int_Total_Error = 1
            Exit Sub
        End Try
        Dim sv As New StreamReader(ft)
        Try
            Do Until sv.Peek() = -1
                str_Ged = sv.ReadLine()
                str_N01 = Mid(str_Ged, 1, 1)
                If str_N01 = "0" Then
                    Call GedCom_Type()
                End If
                If int_GedFound = 1 Then
                    If str_N01 = "1" Then
                        i1 = 0
                        i1 = str_Ged.IndexOf("NAME")
                        If i1 > 0 Then
                            str_Ged2 = Mid(str_Ged, i1 + 6, Len(str_Ged) - 6)
                            Ged_Name(int_Ged_Tab) = str_Ged2
                        End If
                        i1 = 0
                        i1 = str_Ged.IndexOf("SEX")
                        If i1 > 0 Then
                            str_Ged2 = Mid(str_Ged, i1 + 5, Len(str_Ged) - 5)
                            Ged_Geschlecht(int_Ged_Tab) = str_Ged2
                        End If
                        i1 = 0
                        i1 = str_Ged.IndexOf("OCCU")
                        If i1 > 0 Then
                            str_Ged2 = Mid(str_Ged, i1 + 6, Len(str_Ged) - 6)
                            Ged_Beruf(int_Ged_Tab) = str_Ged2
                        End If
                        i1 = 0
                        i1 = str_Ged.IndexOf("BIRT")
                        If i1 > 0 Then
                            Call Ged_Merk_Clear()
                            int_GdMerk_Birt = 1
                        End If
                        i1 = 0
                        i1 = str_Ged.IndexOf("ADDR")
                        If i1 > 0 Then
                            str_Ged2 = Mid(str_Ged, i1 + 6, Len(str_Ged) - 6)
                            Ged_Adresse(int_Ged_Tab) = str_Ged2
                        End If
                        i1 = 0
                        i1 = str_Ged.IndexOf("RELI")
                        If i1 > 0 Then
                            str_Ged2 = Mid(str_Ged, i1 + 6, Len(str_Ged) - 6)
                            Ged_Religion(int_Ged_Tab) = str_Ged2
                            Call Ged_Merk_Clear()
                            int_GdMerk_Reli = 1
                        End If
                        i1 = 0
                        i1 = str_Ged.IndexOf("DEAT")
                        If i1 > 0 Then
                            Call Ged_Merk_Clear()
                            int_GdMerk_Deat = 1
                        End If
                        i1 = 0
                        i1 = str_Ged.IndexOf("CHR")
                        If i1 > 0 Then
                            str_Ged2 = Mid(str_Ged, i1 + 5, Len(str_Ged) - 5)
                            Call Ged_Merk_Clear()
                            int_GdMerk_Chr = 1
                        End If
                    End If
                    If str_N01 = "2" Then
                        i2 = 0
                        i2 = str_Ged.IndexOf("DATE")
                        If i2 > 0 Then str_Ged3 = Mid(str_Ged, i2 + 6, Len(str_Ged) - 6)
                        If i2 > 0 Then
                            If int_GdMerk_Birt = 1 Then
                                Ged_GebDatum(int_Ged_Tab) = str_Ged3
                            End If
                            If int_GdMerk_Buri = 1 Then
                                Ged_BeerdDatum(int_Ged_Tab) = str_Ged3
                            End If
                            If int_GdMerk_Chr = 1 Then
                                Ged_TaufDatum(int_Ged_Tab) = str_Ged3
                            End If
                            If int_GdMerk_Deat = 1 Then
                                Ged_StDatum(int_Ged_Tab) = str_Ged3
                            End If
                        End If
                        i2 = 0
                        i2 = str_Ged.IndexOf("PLAC")
                        If i2 > 0 Then str_Ged3 = Mid(str_Ged, i2 + 6, Len(str_Ged) - 6)
                        If i2 > 0 Then
                            If int_GdMerk_Birt = 1 Then
                                Ged_GebOrt(int_Ged_Tab) = str_Ged3
                            End If
                            If int_GdMerk_Buri = 1 Then
                                Ged_BeerdOrt(int_Ged_Tab) = str_Ged3
                            End If
                            If int_GdMerk_Chr = 1 Then
                                Ged_TaufOrt(int_Ged_Tab) = str_Ged3
                            End If
                            If int_GdMerk_Deat = 1 Then
                                Ged_StOrt(int_Ged_Tab) = str_Ged3
                            End If
                        End If
                    End If
                    ' "SURN"
                    ' "GIVN"
                    ' "SOUR"
                End If
                If int_GedFound = 2 Then int_GedFound = 1
            Loop
            sv.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
            str_ini = ""
        End Try
    End Sub
    Public Shared Sub GedCom_Anz()
        Dim i1 As Integer = str_Ged.IndexOf("INDI")
        If i1 > 0 Then int_GedAnz += 1
    End Sub
    Public Shared Sub GedCom_Type()
        Dim i1 = str_Ged.IndexOf("INDI")
        If i1 > 0 Then
            Call GedCom_ID()
            i1 = 0
        End If
        i1 = str_Ged.IndexOf("FAM")
        If i1 > 0 Then
            Call GedCom_Fam()
        End If
    End Sub
    Public Shared Sub GedCom_ID()
        dbl_GedID = 0
        Dim str_ID As String
        Dim i2 As Integer = 0
        Dim i3 As Integer = 0
        Dim i4 As Integer = 0
        Dim i5 As Integer = Len(str_Ged)
        Dim i1 As Integer = str_Ged.IndexOf("INDI")
        If i1 < 1 Then Exit Sub
        For i2 = 1 To i5
            If i4 = 0 And i3 > 0 And Mid(str_Ged, i2, 1) = "@" Then i4 = i2 : Exit For
            If i3 = 0 And Mid(str_Ged, i2, 1) = "@" Then i3 = i2 + 2
        Next
        int_Ged_Tab += 1
        str_ID = Mid(str_Ged, i3, i4 - i3)
        dbl_GedID = Val(str_ID)
        Ged_ID(int_Ged_Tab) = dbl_GedID
        int_GedFound = 2
    End Sub
    Public Shared Sub GedCom_Fam()

    End Sub
    Public Shared Sub GedEhe1_ID()

    End Sub

    Public Shared Sub GedEhe2_ID()

    End Sub

    Public Shared Sub Ged_Merk_Clear()
        int_GdMerk_Birt = 0
        int_GdMerk_Buri = 0
        int_GdMerk_Chr = 0
        int_GdMerk_Deat = 0
        int_GdMerk_Reli = 0
    End Sub

    REM **************************************************************
    REM *  Transfer starten                                          *
    REM **************************************************************
    Public Shared Sub Transfer_Tabellen()

        REM  Personendaten
        Call TransferGedPersNr()
        Call Trans_GedPersonen()
        REM  Ehedaten
        Call Trans_GedEhe()
        REM  Paten/Zeugen
        'Call Trans_Paten()
        'Call Trans_Zeugen()
        REM  Sonstiges
        Call Trans_GedSonstiges()

    End Sub

    REM **********************************************************
    REM *  Lesen der Tabelle und speichern der Personennummer    *
    REM **********************************************************
    Public Shared Sub TransferGedPersNr()

    End Sub

    REM ******************************************************************
    REM *  Read der einzelnen Datensätze auf Grund der Nummer            *
    REM ******************************************************************
    Public Shared Sub Trans_GedPersonen()
        Call Trans_GedNeu()

        With NM_Info
            .lbl_Info01.Text = "Anzahl Datensätze Person"
            .lbl_Info01Z.Text = int_Imp01.ToString

            .lbl_Info02.Text = "Anzahl Datensätze Taufe"
            .lbl_Info02Z.Text = int_Imp02.ToString

            .lbl_Info03.Text = "Anzahl Datensätze Beerdigung"
            .lbl_Info03Z.Text = int_Imp03.ToString

            .lbl_Info04.Text = "Anzahl Datensätze Adresse"
            .lbl_Info04Z.Text = int_Imp04.ToString

            .lbl_Info05.Text = "Anzahl Datensätze Text"
            .lbl_Info05Z.Text = int_Imp05.ToString

            .lbl_Info06.Text = "Anzahl Datensätze Rolle"
            .lbl_Info06Z.Text = int_Imp06.ToString

            .lbl_Info07.Text = "Anzahl Datensätze Berufe"
            .lbl_Info07Z.Text = int_Imp07.ToString

            .lbl_Info08.Text = "Anzahl Datensätze Ehe"
            .lbl_Info08Z.Text = int_Imp08.ToString

            .lbl_Info09.Text = "Anzahl Datensätze Bilder"
            .lbl_Info09Z.Text = int_Imp09.ToString

            .lbl_Info10.Text = "Anzahl Info Pate"
            .lbl_Info10Z.Text = int_Imp10.ToString

            .lbl_Info11.Text = "Anzahl Info Trauzeuge"
            .lbl_Info11Z.Text = int_Imp11.ToString

            .Refresh()
        End With

        Call Ged_famadr()
        Call Ged_famdat()
        Call Ged_famehe()

        conGM.Close()
        con.Close()

        REM *  Logdatei füllen
        Using sw As StreamWriter = File.AppendText(str_LogFile)
            GM_str_1 = "Anzahl Datensätze Person    : " + int_Imp01.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Taufe     : " + int_Imp02.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Beerdigung: " + int_Imp03.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Adresse   : " + int_Imp04.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Text      : " + int_Imp05.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Rolle     : " + int_Imp06.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Berufe    : " + int_Imp07.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Ehe       : " + int_Imp08.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Datensätze Bilder    : " + int_Imp09.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Info Pate            : " + int_Imp10.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Anzahl Info Trauzeuge       : " + int_Imp11.ToString
            sw.WriteLine(GM_str_1)
            GM_str_1 = "Ende Import: " + DateTime.Now
            sw.WriteLine(GM_str_1)
        End Using

        NM_Info.Visible = False
        NM_Ahnen.Enabled = True
        NM_Ahnen.Visible = True
        NM_Ahnen.Show()

        REM *  Neustart mit neu angelegter Datenbank
        Call Load_INI()
        Call Open_DB()
        Call Open_Para()
        Call Grundwerte()
        Call Blaettern_First()


    End Sub

    Public Shared Sub Trans_GedNeu()

        Call Trans_GedNeu_t01()
        Call Trans_GedNeu_t02()
        Call Trans_GedNeu_t03()
        Call Trans_GedNeu_t05_Eltern()
        Call Trans_GedNeu_t12()

    End Sub

    Public Shared Sub Trans_GedNeu_t01()


        Dim i1 As Integer
        Dim str_H1 As String

        For i1 = 1 To int_GedAnz
            With NM_Ahnen
                dbl_Max_ID = Val(Ged_ID(i1))
                p_int_ID = dbl_Max_ID

                str_H1 = Ged_Name(i1)
                Call Trans_GedName(Ged_Name(i1), Ged_Geschlecht(i1))

                .tx_10_Name.Text = Ged_Name(i1)
                .tx_10_NameZ.Text = ""
                .tx_10_GebName.Text = ""
                .tx_10_Vorname.Text = ""
                .tx_10_Titel.Text = ""
                .tx_10_Vater.Text = "0"
                .tx_10_Mutter.Text = "0"
                .tx_10_Geschl.Text = Ged_Geschlecht(i1)
                .tx_10_GDat_TT.Text = Mid(Ged_GebDatum(i1), 1, 2)
                .tx_10_GDat_MM.Text = Mid(Ged_GebDatum(i1), 4, 2)
                .tx_10_GDat_JJ.Text = Mid(Ged_GebDatum(i1), 7, 4)
                int_GDat_Art = 1
                If GM1_GebTag = "<" Then int_GDat_Art = 2
                If GM1_GebTag = ">" Then int_GDat_Art = 3
                If GM1_GebTag = "<>" Then int_GDat_Art = 4
                .tx_10_GOrt.Text = Ged_GebOrt(i1)
                .tx_10_SDat_TT.Text = Mid(Ged_StDatum(i1), 1, 2)
                .tx_10_SDat_MM.Text = Mid(Ged_StDatum(i1), 4, 2)
                .tx_10_SDat_JJ.Text = Mid(Ged_StDatum(i1), 7, 4)
                int_SDat_Art = 1
                If GM1_StTag = "<" Then int_SDat_Art = 2
                If GM1_StTag = ">" Then int_SDat_Art = 3
                If GM1_StTag = "<>" Then int_SDat_Art = 4
                .tx_10_SOrt.Text = Ged_StOrt(i1)
                str_AktDat = ""

            End With

            Call Person_Insert()
            int_Imp01 += 1
        Next i1
    End Sub

    Public Shared Sub Trans_GedName(ByVal str_X1 As String, ByVal str_X2 As String)

        Dim i31 As Integer
        Dim i33 As Integer
        Dim str_31 As String = ""
        Dim str_32 As String = ""
        Dim str_33 As String = ""

        i31 = str_X1.IndexOf("/")
        If i31 > 0 Then
            str_31 = Mid(str_X1, 1, i31 - 1)
            str_32 = Mid(str_X1, i31 + 1, Len(str_X1 - i31))
        End If
        If str_32 > "" Then
            i33 = str_32.IndexOf("/")
            If i33 > 0 Then
                str_33 = Mid(str_32, 1, (Len(str_32 - 1)))

            End If

        End If
        Trim(str_31)
        Trim(str_33)
        NM_Ahnen.tx_10_GebName.Text = str_33
        NM_Ahnen.tx_10_Vorname.Text = str_31
        If str_X2 = "M" Then NM_Ahnen.tx_10_Name.Text = str_33


    End Sub

    Public Shared Sub Trans_GedNeu_t02()

        REM Prüfen auf Daten
        If GM1_TaufDat = "" And GM1_TaufIn = "" And GM1_KonfDat = "" And GM1_Konfin = "" And GM1_KonRegin = "" And GM1_Text = "" And GM1_GebRegIn = "" Then
            Exit Sub
        End If

        With NM_Ahnen

            .cbx_11_Konf.Text = GM1_Konfess
            .tx_11_TDat_TT.Text = Mid(GM1_TaufDat, 1, 2)
            .tx_11_TDat_MM.Text = Mid(GM1_TaufDat, 3, 2)
            .tx_11_TDat_JJ.Text = Mid(GM1_TaufDat, 5, 4)
            .tx_11_Tauf_Ort.Text = GM1_TaufIn
            .tx_11_Tauf_Kirche.Text = GM1_TaufKirche

            .tx_11_FDat_TT.Text = Mid(GM1_KonfDat, 1, 2)
            .tx_11_FDat_MM.Text = Mid(GM1_KonfDat, 3, 2)
            .tx_11_FDat_JJ.Text = Mid(GM1_KonfDat, 5, 4)
            .tx_11_FOrt.Text = GM1_Konfin
            .rtx_11_Bemerk.Text = ""
        End With

        Call Person_Taufe_Insert()
        int_Imp02 += 1

    End Sub

    REM ************************************************************
    REM *  GM1_TaufIn trennen in Ort und Kirche                    *
    REM ************************************************************
    Public Shared Sub Tauf_Ort()
        Dim str_Tauf1 As String = ""
        Dim str_Tauf2 As String = ""
        Dim int_k1 As Integer = Len(GM1_TaufIn)
        Dim int_k2 As Integer = 0
        Dim int_k3 As Integer = 0

        If int_k1 < 2 Then Exit Sub
        For int_k2 = 1 To int_k1
            If Mid(GM1_TaufIn, int_k2, 1) = " " Then
                str_Tauf1 = Mid(GM1_TaufIn, 1, (int_k2 - 1))
                str_Tauf2 = Mid(GM1_TaufIn, int_k2 + 1, int_k1 - int_k2)
                Exit For
            Else
                If Mid(GM1_TaufIn, int_k2, 1) = "," Then
                    str_Tauf2 = Mid(GM1_TaufIn, 1, (int_k2 - 1))
                    str_Tauf1 = Mid(GM1_TaufIn, int_k2 + 1, int_k1 - int_k2)
                    Exit For
                Else
                    str_Tauf1 = GM1_TaufIn
                End If
            End If
        Next

        GM1_TaufIn = str_Tauf1
        GM1_TaufKirche = str_Tauf2
        If Mid(GM1_TaufKirche, 1, 1) = "(" Then Mid(GM1_TaufKirche, 1, 1) = " "
        If Mid(GM1_TaufKirche, 2, 1) = "(" Then Mid(GM1_TaufKirche, 2, 1) = " "
        Trim(GM1_TaufIn)
        Trim(GM1_TaufKirche)

    End Sub

    Public Shared Sub Trans_GedNeu_t03()

        REM Prüfen auf Daten
        If GM1_BeerdDat = "" And GM1_BeerdIn = "" And GM1_GrabIn = "" And GM1_GrabNr = "" And GM1_Todesursache = "" Then
            Exit Sub
        End If

        With NM_Ahnen
            .tx_12_BDat_TT.Text = Mid(GM1_BeerdDat, 1, 2)
            .tx_12_BDat_MM.Text = Mid(GM1_BeerdDat, 3, 2)
            .tx_12_BDat_JJ.Text = Mid(GM1_BeerdDat, 5, 4)
            .tx_12_B_Ort.Text = GM1_BeerdIn
            .tx_12_Friedhof.Text = GM1_GrabIn
            .tx_12_Grablage.Text = GM1_GrabNr
            .tx_12_Tod_Ursache.Text = GM1_Todesursache
            .tx_12_Priester.Text = ""
            .rtx_12_Bemerk.Text = ""
        End With

        Call Person_Beerd_Insert()
        int_Imp03 += 1

    End Sub

    Public Shared Sub Trans_GedNeu_t05_Eltern()
        If GM1_Vater > "0" Then
            REM *   Vaterdaten
            Call DB_Tab_High("t05_ID", "t05_Rolle")
            dbl_Max_ID += 1

            str_DBD_t05 = " Values (" + dbl_Max_ID.ToString + ", "
            str_DBD_t05 += "'" + GM1_Vater + "', "
            str_DBD_t05 += "3,"
            str_DBD_t05 += "'" + GM_Nr + "')"

            mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 + str_DBD_t05
            Call DB_Execute()
            int_Imp06 += 1
        End If

        If GM1_Mutter > "0" Then
            REM *  Mutterdaten
            Call DB_Tab_High("t05_ID", "t05_Rolle")
            dbl_Max_ID += 1

            str_DBD_t05 = " Values (" + dbl_Max_ID.ToString + ", "
            str_DBD_t05 += "'" + GM1_Mutter + "', "
            str_DBD_t05 += "3,"
            str_DBD_t05 += "'" + GM_Nr + "')"

            mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 + str_DBD_t05
            Call DB_Execute()
            int_Imp06 += 1
        End If

    End Sub

    Public Shared Sub Trans_GedNeu_t12()

        If GM1_Text = "" Then
            Exit Sub
        End If

        With NM_Ahnen
            .rtx_16_1.Text = GM1_Text
            Call Person_Text_Insert()
            int_Imp05 += 1
        End With

    End Sub

    Public Shared Sub Trans_GedEhe()

    End Sub

    Public Shared Sub Trans_GedSonstiges()

    End Sub

    REM **************************************************************
    REM *  Prüfen File auf Vorhandensein                             *
    REM **************************************************************
    Public Shared Sub GM_Exists()

        Dim i11 As Integer
        Dim i12 As Integer

        If File.Exists(str_PfadGM) Then
            i11 = Len(str_FileGM)
            For i12 = i11 To 0 Step -1
                If Mid(str_FileGM, i12, 1) = "." Then
                    str_DateiEndung = Mid(str_FileName, i12 + 1, i11 - i12)
                    str_FileName = Mid(str_FileName, 1, i12 - 1)
                    If int_Merk_Bild = 1 Then
                        Exit Sub
                    End If
                End If
            Next
        End If

    End Sub

    REM ****************************************************************
    REM *  Dazulesen weiterer Tabellen                                 *
    REM ****************************************************************
    Public Shared Sub Ged_famadr()


    End Sub

    Public Shared Sub Trans_Neu_t06()

        REM Prüfen auf Daten
        If GM4_bis = "" And GM4_von = "" And GM4_Land = "" And GM4_PLZ = "" And GM4_Strasse = "" Then
            Exit Sub
        End If

        With NM_Ahnen
            .tx_14_Land.Text = GM4_Land
            .tx_14_PLZ.Text = GM4_PLZ
            .tx_14_Strasse.Text = GM4_Strasse
            .tx_14_Ort.Text = GM4_Ort
            .tx_14_Dat1_TT.Text = Mid(GM4_von, 1, 2)
            .tx_14_Dat1_MM.Text = Mid(GM4_von, 3, 2)
            .tx_14_Dat1_JJ.Text = Mid(GM4_von, 5, 4)
            .tx_14_Dat2_TT.Text = Mid(GM4_bis, 1, 2)
            .tx_14_Dat2_MM.Text = Mid(GM4_bis, 3, 2)
            .tx_14_Dat2_JJ.Text = Mid(GM4_bis, 5, 4)
            .rtx_12_Bemerk.Text = ""
        End With

        Call Person_Adresse_Insert()
        int_Imp04 += 1

        NM_Info.lbl_Info04.Text = "Anzahl Datensätze Adresse"
        NM_Info.lbl_Info04Z.Text = int_Imp04.ToString
        NM_Info.Refresh()

    End Sub

    REM ****************************************************************
    REM *  Dazulesen weiterer Tabellen (Berufe)                        *
    REM ****************************************************************
    Public Shared Sub Ged_famdat()


    End Sub

    Public Shared Sub Trans_GedNeu_t07()

        REM Prüfen auf Daten
        If GM5_Text > "" Then
            With NM_Ahnen
                .tx_15_Beruf.Text = GM5_Text
            End With
            Call Person_Beruf_Insert()
            int_Imp07 += 1

            NM_Info.lbl_Info07.Text = "Anzahl Datensätze Berufe"
            NM_Info.lbl_Info07Z.Text = int_Imp07.ToString
            NM_Info.Refresh()
        End If

    End Sub

    REM ******************************************************************
    REM *  Ehedaten übernehmen                                           *
    REM ******************************************************************
    Public Shared Sub Ged_famehe()



    End Sub

    Public Shared Sub Trans_GedNeu_t041()

        dbl_ID = Val(GM6_ID1)
        dbl_Sel_ID = Val(GM6_ID2)

        With NM_Ahnen
            .tx_13_Dat1_TT.Text = GM6_SDat_TT
            .tx_13_Dat1_MM.Text = GM6_SDat_MM
            .tx_13_Dat1_JJ.Text = GM6_SDat_JJ
            'int_EDat1_Art = 1
            .tx_13_Ort1.Text = GM6_S_Ort
            .tx_13_Beamter.Text = GM6_S_Beamter
            .tx_13_Dat2_TT.Text = GM6_KDat_TT
            .tx_13_Dat2_MM.Text = GM6_KDat_MM
            .tx_13_Dat2_JJ.Text = GM6_KDat_JJ
            'int_EDat2_Art = 1
            .tx_13_Ort2.Text = GM6_K_Ort
            .tx_13_Kirche.Text = GM6_Kirche
            .tx_13_Priester.Text = GM6_K_Priester
            .tx_13_Dat3_TT.Text = GM6_SEnde_TT
            .tx_13_Dat3_MM.Text = GM6_SEnde_MM
            .tx_13_Dat3_JJ.Text = GM6_SEnde_JJ
            'int_EDat3_Art = 1
            .rtx_13_Bemerk.Text = GM6_Text

            Call Person_Ehe_041()
            int_Imp08 += 1

        End With

        NM_Info.lbl_Info08.Text = "Anzahl Datensätze Ehe"
        NM_Info.lbl_Info08Z.Text = int_Imp08.ToString
        NM_Info.Refresh()

    End Sub

    Public Shared Sub Trans_Update_t02()

        dbl_ID = Val(GM6_ID1)
        str_UString += "t02_Bemerk = '" + GM5_Text + ""

        Call Person_Update_T02()

    End Sub

End Class