﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen.Cls_02_DB_Person_Read
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_50_Daten_10
Imports NM_Ahnen.My.Resources

Public Class Cls_09_Mask_Person
    REM ***********************************************************************
    REM *  Anzeige der Personendaten und aller Bezugspersonen                 *
    REM ***********************************************************************
    Public Shared Sub Mask_Out_Person()
        Call Altersermittlung()
        With NM_Ahnen
            Call Mask_Reiter()
            Call Mask_Out_Header()
            Call Mask_Out_Vater()
            Call Mask_Out_Mutter()
            Call Mask_Out_10()
            REM *----------------------------------------------------*
            REM *  Ergänzungswerte dazulesen                         *
            REM *----------------------------------------------------*
            Call Mask_Out_Komm()
            Call Mask_Out_Grid_Ehe()
            Call Mask_Out_Grid_Geschwister()
            Call Mask_Out_Grid_Kinder()
            Call Mask_Out_11()
            Call Mask_Out_12()
            Call Mask_Out_13()
            Call Mask_Out_14()
            Call Mask_Out_15()
            Call Mask_Out_16()
            Call Mask_Out_17()
            REM *----------------------------------------------------*
            REM *  Sortierung der einzelnen Grids ausführen          *
            REM *----------------------------------------------------*
            '.dgv_Geschwister.Sort(.dgv_Geschwister.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_Ehen.Sort(.dgv_Ehen.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_Kinder.Sort(.dgv_Kinder.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_11_Paten.Sort(.dgv_11_Paten.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_13_TZ1.Sort(.dgv_13_TZ1.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_13_TZ2.Sort(.dgv_13_TZ2.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_14_Adr.Sort(.dgv_14_Adr.Columns(2), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_15_Beruf.Sort(.dgv_15_Beruf.Columns(2), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_17_Paten.Sort(.dgv_17_Paten.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
            .dgv_17_Zeugen.Sort(.dgv_17_Zeugen.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
        End With
    End Sub

    REM **************************************************************
    REM *  Prüfen Tabellenreiter, evtl. aus Versalien umsetzen       *
    REM **************************************************************
    Public Shared Sub Mask_Reiter()
        REM *-------------------------------------------------------------*
        REM *  Textdarstellung der Tabellenreiter                         *
        REM *  falls Daten vorhanden, wird Text in Versalien gezeigt      *
        REM *-------------------------------------------------------------*
        With NM_Ahnen
            .Tab_Grund.Text = tab_Reiter(0)
            If int_Merk_Tab_Grund = 1 Then
                .Tab_Grund.Text = tab_Reiter(0).ToUpper
                .Tab_Grund.ForeColor = col_TabPositiv
            End If
            .Tab_Taufe.Text = tab_Reiter(1)
            If int_Merk_Tab_Taufe = 1 Then
                .Tab_Taufe.Text = tab_Reiter(1).ToUpper
                .Tab_Taufe.ForeColor = col_TabPositiv
            End If
            .Tab_Beerd.Text = tab_Reiter(2)
            If int_Merk_Tab_Beerd = 1 Then
                .Tab_Beerd.Text = tab_Reiter(2).ToUpper
                .Tab_Beerd.ForeColor = col_TabPositiv
            End If
            .Tab_Ehe.Text = tab_Reiter(3)
            If int_Merk_Tab_Ehe = 1 Then
                .Tab_Ehe.Text = tab_Reiter(3).ToUpper
                .Tab_Ehe.ForeColor = col_TabPositiv
            End If
            .Tab_Anschr.Text = tab_Reiter(4)
            If int_Merk_Tab_Anschr = 1 Then
                .Tab_Anschr.Text = tab_Reiter(4).ToUpper
                .Tab_Anschr.ForeColor = col_TabPositiv
            End If
            .Tab_Beruf.Text = tab_Reiter(5)
            If int_Merk_Tab_Beruf = 1 Then
                .Tab_Beruf.Text = tab_Reiter(5).ToUpper
                .Tab_Beruf.ForeColor = col_TabPositiv
            End If
            .Tab_Text.Text = tab_Reiter(6)
            If int_Merk_Tab_Text = 1 Then
                .Tab_Text.Text = tab_Reiter(6).ToUpper
                .Tab_Text.ForeColor = col_TabPositiv
            End If
            .Tab_Paten.Text = tab_Reiter(7)
            If int_Merk_Tab_Paten = 1 Then
                .Tab_Paten.Text = tab_Reiter(7).ToUpper
                .Tab_Paten.ForeColor = col_TabPositiv
            End If
        End With
    End Sub

    REM **************************************************************
    REM *  Personendaten für Headeranzeige zusammensetzen            *
    REM **************************************************************
    Public Shared Sub Mask_Out_Header()
        With NM_Ahnen
            .tx_001_ID.Text = p_int_ID.ToString
            .lbx_01_Person.Text = p_int_ID.ToString
            If p_str_Name > "" Then .lbx_01_Person.Text += ",   " + p_str_Name
            If p_str_GebName > "" And p_str_GebName <> p_str_Name Then .lbx_01_Person.Text += ", geb. " + p_str_GebName
            If p_str_Name > "" Then
                .lbx_01_Person.Text += ", " + p_str_Vorname
                .lbx_01_Person.Text += " (Alter: " + int_Diff_J.ToString + " Jahre)"
            End If
        End With
    End Sub

    REM **************************************************************
    REM *  Aufbereiten der Anzeige Vater                             *
    REM **************************************************************
    Public Shared Sub Mask_Out_Vater()
        With NM_Ahnen
            .lbx_01_Vater1.Text = ""
            .lbx_01_Vater2.Text = ""
            str_HFeld = ""
            .bt_01_Vater.Visible = False
            If v_lng_ID > 0 Then
                If v_str_Name = v_str_GebName Then v_str_GebName = ""
                If v_lng_ID > 0 Then str_HFeld = "(" + v_lng_ID.ToString + ") " + v_str_Name
                If v_str_GebName <> "" Then str_HFeld = str_HFeld + ", geb. " + v_str_GebName
                If v_str_Vorname <> "" Then str_HFeld = str_HFeld + ", " + v_str_Vorname
                .lbx_01_Vater1.ForeColor = col_tx_Mann
                .lbx_01_Vater1.Text = str_HFeld
                If str_HFeld > "" Then .bt_01_Vater.Visible = True
                str_HFeld = ""
                If v_str_GDat_TT <> "" Or v_str_GDat_MM <> "" Or v_str_GDat_JJ <> "" Then
                    str_HFeld = "* " + v_str_GDat_TT + "." + v_str_GDat_MM + "." + v_str_GDat_JJ
                End If
                If v_str_GOrt <> "" Then str_HFeld = str_HFeld + ", " + v_str_GOrt
                If v_str_SDat_TT <> "" Or v_str_SDat_MM <> "" Or v_str_SDat_JJ <> "" Then
                    str_HFeld = str_HFeld + ", + " + v_str_SDat_TT + "." + v_str_SDat_MM + "." + v_str_SDat_JJ
                End If
                If v_str_SOrt <> "" Then str_HFeld = str_HFeld + ", " + v_str_SOrt
                .lbx_01_Vater2.ForeColor = col_tx_Mann
                .lbx_01_Vater2.Text = str_HFeld
            End If
        End With
    End Sub

    REM **************************************************************
    REM *  Aufbereiten der Anzeige Mutter                            *
    REM **************************************************************
    Public Shared Sub Mask_Out_Mutter()
        With NM_Ahnen

            .lbx_01_Mutter1.Text = ""
            .lbx_01_Mutter2.Text = ""
            str_HFeld = ""
            .bt_01_Mutter.Visible = False

            If m_lng_ID > 0 Then
                If m_str_Name = m_str_GebName Then m_str_GebName = ""
                If m_lng_ID > 0 Then str_HFeld = "(" + m_lng_ID.ToString + ") " + m_str_Name
                If m_str_GebName <> "" Then str_HFeld = str_HFeld + ", geb. " + m_str_GebName
                If m_str_Vorname <> "" Then str_HFeld = str_HFeld + ", " + m_str_Vorname
                .lbx_01_Mutter1.ForeColor = col_tx_Frau
                .lbx_01_Mutter1.Text = str_HFeld
                If str_HFeld <> "" Then .bt_01_Mutter.Visible = True
                str_HFeld = ""
                If m_str_GDat_TT <> "" Or m_str_GDat_MM <> "" Or m_str_GDat_JJ <> "" Then
                    str_HFeld = "* " + m_str_GDat_TT + "." + m_str_GDat_MM + "." + m_str_GDat_JJ
                End If
                If m_str_GOrt <> "" Then str_HFeld = str_HFeld + ", " + m_str_GOrt
                If m_str_SDat_TT <> "" Or m_str_SDat_MM <> "" Or m_str_SDat_JJ <> "" Then
                    str_HFeld = str_HFeld + ", + " + m_str_SDat_TT + "." + m_str_SDat_MM + "." + m_str_SDat_JJ
                End If
                If m_str_SOrt <> "" Then str_HFeld = str_HFeld + ", " + m_str_SOrt
                .lbx_01_Mutter2.ForeColor = col_tx_Frau
                .lbx_01_Mutter2.Text = str_HFeld
            End If
        End With
    End Sub

    REM ***************************************************************
    REM *  Anzeigen der Personendaten (Grunddaten)                    *
    REM ***************************************************************
    Public Shared Sub Mask_Out_10()
        With NM_Ahnen
            .tx_10_Name.Text = p_str_Name
            .tx_10_GebName.Text = p_str_GebName
            .tx_10_Vorname.Text = p_str_Vorname
            .tx_10_Rufname.Text = p_str_Rufname
            .tx_10_NameZ.Text = p_str_NameZ
            .tx_10_SpitzN.Text = p_str_SpitzN
            .tx_10_Geschl.Text = p_str_Geschl
            .tx_10_Titel.Text = p_str_Titel
            .tx_10_Vater.Text = p_int_Vater.ToString
            .tx_10_Mutter.Text = p_int_Mutter.ToString
            .tx_10_GDat_TT.Text = p_str_GDat_TT
            .tx_10_GDat_MM.Text = p_str_GDat_MM
            .tx_10_GDat_JJ.Text = p_str_GDat_JJ
            If p_str_GDat_TT = "" And p_str_GDat_MM = "" And p_str_GDat_JJ = "" Then p_int_GArt = 0
            .cbx_10_GDat.Text = str_Para_DA(p_int_GArt)
            .tx_10_GOrt.Text = p_str_GOrt
            .lbl_10_IGurk.Text = p_str_Quelle(1)
            .lbl_10_IGurk2.Text = p_str_Quelle(2)
            .tx_10_SDat_TT.Text = p_str_SDat_TT
            .tx_10_SDat_MM.Text = p_str_SDat_MM
            .tx_10_SDat_JJ.Text = p_str_SDat_JJ
            If p_str_SDat_TT = "" And p_str_SDat_MM = "" And p_str_SDat_JJ = "" Then p_int_SArt = 0
            .cbx_10_SDat.Text = str_Para_DA(p_int_SArt)
            .tx_10_SOrt.Text = p_str_SOrt
            .lbl_10_ISurk.Text = p_str_Quelle(3)
            .lbl_10_ISUrk2.Text = p_str_Quelle(4)
            Call TabPos_Mask10()
        End With
    End Sub

    REM ***************************************************************
    REM *  Anzeigen der Personendaten (Taufdaten)                     *
    REM ***************************************************************
    Public Shared Sub Mask_Out_11()
        With NM_Ahnen
            .tx_11_TDat_TT.Text = p_str_TDat_TT
            .tx_11_TDat_MM.Text = p_str_TDat_MM
            .tx_11_TDat_JJ.Text = p_str_TDat_JJ
            If p_str_TDat_TT = "" And p_str_TDat_MM = "" And p_str_TDat_JJ = "" Then p_int_TDat_Art = 0
            .cbx_11_TDat_Art.Text = str_Para_DA(p_int_TDat_Art)
            .tx_11_Tauf_Ort.Text = p_str_TOrt
            .tx_11_Tauf_Kirche.Text = p_str_TKirche
            .lbl_11_ITUrk.Text = p_str_Quelle(5)
            .tx_11_Priester.Text = p_str_TPriester
            .cbx_11_Konf.Text = p_str_Konf
            .tx_11_FDat_TT.Text = p_str_FDat_TT
            .tx_11_FDat_MM.Text = p_str_FDat_MM
            .tx_11_FDat_JJ.Text = p_str_FDat_JJ
            If p_str_FDat_TT = "" And p_str_FDat_MM = "" And p_str_FDat_JJ = "" Then p_int_FDat_Art = 0
            .cbx_11_FDat_Art.Text = str_Para_DA(p_int_FDat_Art)
            .tx_11_FOrt.Text = p_str_FOrt
            .tx_11_FKirche.Text = p_str_FKirche
            .lbl_11_IFUrk.Text = p_str_Quelle(6)
            .tx_11_FPriester.Text = p_str_FPriester
            .rtx_11_Bemerk.Text = p_str_TBemerk
            .dgv_11_Paten.Rows.Clear()
            If int_Pate1 >= 0 Then
                For int_l01 = 0 To int_Pate1
                    r_lng_ID = tp1_lng_ID(int_l01)
                    r_str_Name = tp1_str_Name(int_l01)
                    r_str_GebName = tp1_str_GebName(int_l01)
                    r_str_Vorname = tp1_str_Vorname(int_l01)
                    r_str_GOrt = tp1_str_GOrt(int_l01)
                    r_str_SOrt = tp1_str_SOrt(int_l01)
                    r_str_GDat_JJ = tp1_str_GDat_JJ(int_l01)
                    r_str_GDat_MM = tp1_str_GDat_MM(int_l01)
                    r_str_GDat_TT = tp1_str_GDat_TT(int_l01)
                    r_str_SDat_JJ = tp1_str_SDat_JJ(int_l01)
                    r_str_SDat_MM = tp1_str_SDat_MM(int_l01)
                    r_str_SDat_TT = tp1_str_SDat_TT(int_l01)
                    r_str_Geschl = tp1_str_Geschl(int_l01)
                    Call Color_Geschlecht()
                    Call Erm_HDat()
                    REM *--------------------------------------------*
                    REM *  Füllen des DataGrids                      *
                    REM *--------------------------------------------*
                    With .dgv_11_Paten
                        .Rows.Add(r_lng_ID.ToString("###0"), r_str_Name, r_str_GebName, r_str_Vorname, str_HDat1, str_HDat2, str_X, str_HDat3)
                        .Rows(int_l01).DefaultCellStyle.ForeColor = col_tx_Geschl
                    End With
                Next
            End If
        End With
    End Sub

    REM ***************************************************************
    REM *  Anzeigen der Personendaten (Beerdigung)                    *
    REM ***************************************************************
    Public Shared Sub Mask_Out_12()
        With NM_Ahnen
            .tx_12_BDat_TT.Text = p_str_BDat_TT
            .tx_12_BDat_MM.Text = p_str_BDat_MM
            .tx_12_BDat_JJ.Text = p_str_BDat_JJ
            If p_str_BDat_TT = "" And p_str_BDat_MM = "" And p_str_BDat_JJ = "" Then p_int_BDat_Art = 0
            .cbx_12_BDat_Art.Text = str_Para_DA(p_int_BDat_Art)
            .tx_12_B_Ort.Text = p_str_BOrt
            .tx_12_Friedhof.Text = p_str_Friedhof
            .tx_12_Grablage.Text = p_str_Grablage
            .tx_12_Priester.Text = p_str_BPriester
            .tx_12_B_Art.Text = p_str_BArt
            .lbl_12_ISUrk.Text = p_str_Quelle(7)
            .lbl_12_ISUrk2.Text = p_str_Quelle(8)
            .tx_12_Tod_Ursache.Text = p_str_TodUrsache
            .rtx_12_Bemerk.Text = p_str_BBemerk
        End With
    End Sub

    REM ***************************************************************
    REM *  Anzeigen der Personendaten (Ehedaten)                      *
    REM ***************************************************************
    Public Shared Sub Mask_Out_13()
        With NM_Ahnen
            .rtx_13_Bemerk.Text = p_str_E_Bemerk
            .dgv_13_TZ1.Rows.Clear()
            If int_Zeuge1 >= 0 Then
                For int_l01 = 0 To int_Zeuge1
                    r_lng_ID = tz1_lng_ID(int_l01)
                    r_str_Name = tz1_str_Name(int_l01)
                    r_str_GebName = tz1_str_GebName(int_l01)
                    r_str_Vorname = tz1_str_Vorname(int_l01)
                    r_str_GOrt = tz1_str_GOrt(int_l01)
                    r_str_SOrt = tz1_str_SOrt(int_l01)
                    r_str_GDat_JJ = tz1_str_GDat_JJ(int_l01)
                    r_str_GDat_MM = tz1_str_GDat_MM(int_l01)
                    r_str_GDat_TT = tz1_str_GDat_TT(int_l01)
                    r_str_SDat_JJ = tz1_str_SDat_JJ(int_l01)
                    r_str_SDat_MM = tz1_str_SDat_MM(int_l01)
                    r_str_SDat_TT = tz1_str_SDat_TT(int_l01)
                    r_str_Geschl = tz1_str_Geschl(int_l01)
                    Call Color_Geschlecht()
                    Call Erm_HDat()
                    REM *--------------------------------------------*
                    REM *  Füllen des DataGrids                      *
                    REM *--------------------------------------------*
                    With .dgv_13_TZ1
                        .Rows.Add(r_lng_ID.ToString("###0"), r_str_Name, r_str_GebName, r_str_Vorname, str_HDat1, str_HDat2, str_X, str_HDat3)
                        .Rows(int_l01).DefaultCellStyle.ForeColor = col_tx_Geschl
                    End With
                Next
            End If
            .dgv_13_TZ2.Rows.Clear()
            If int_Zeuge2 >= 0 Then
                For int_l01 = 0 To int_Zeuge2
                    r_lng_ID = tz2_lng_ID(int_l01)
                    r_str_Name = tz2_str_Name(int_l01)
                    r_str_GebName = tz2_str_GebName(int_l01)
                    r_str_Vorname = tz2_str_Vorname(int_l01)
                    r_str_GOrt = tz2_str_GOrt(int_l01)
                    r_str_SOrt = tz2_str_SOrt(int_l01)
                    r_str_GDat_JJ = tz2_str_GDat_JJ(int_l01)
                    r_str_GDat_MM = tz2_str_GDat_MM(int_l01)
                    r_str_GDat_TT = tz2_str_GDat_TT(int_l01)
                    r_str_SDat_JJ = tz2_str_SDat_JJ(int_l01)
                    r_str_SDat_MM = tz2_str_SDat_MM(int_l01)
                    r_str_SDat_TT = tz2_str_SDat_TT(int_l01)
                    r_str_Geschl = tz2_str_Geschl(int_l01)
                    Call Color_Geschlecht()
                    Call Erm_HDat()
                    REM *--------------------------------------------*
                    REM *  Füllen des DataGrids                      *
                    REM *--------------------------------------------*
                    With .dgv_13_TZ2
                        .Rows(int_l01).DefaultCellStyle.ForeColor = col_tx_Geschl
                        .Rows.Add(r_lng_ID.ToString("###0"), r_str_Name, r_str_GebName, r_str_Vorname, str_HDat1, str_HDat2, str_X, str_HDat3)
                    End With
                Next
            End If

        End With
    End Sub

    REM ******************************************************
    REM *  Tabellenreiter Anschriften                        *
    REM ******************************************************
    Public Shared Sub Mask_Out_14()
        With NM_Ahnen
            .dgv_14_Adr.Rows.Clear()
            If int_Adr >= 0 Then
                REM *--------------------------------------------*
                REM *  Füllen des DataGrids                      *
                REM *--------------------------------------------*
                For int_l01 = 0 To int_Adr
                    str_HDat1 = ta_dt_DatVon(int_l01)
                    str_HDat2 = ta_dt_DatBis(int_l01)
                    With .dgv_14_Adr.Rows
                        .Add(ta_int_LFD(int_l01).ToString("##0"), str_HDat1, str_HDat2, ta_str_PLZ(int_l01), ta_str_Ort(int_l01), ta_str_Strasse(int_l01), ta_str_Land(int_l01))
                    End With
                Next
            End If
        End With
    End Sub

    REM ******************************************************
    REM *  Tabellenreiter Berufe                             *
    REM ******************************************************
    Public Shared Sub Mask_Out_15()
        With NM_Ahnen
            .dgv_15_Beruf.Rows.Clear()

            If int_Beruf >= 0 Then
                For int_l01 = 0 To int_Beruf
                    str_HDat1 = tb_dt_DatVon(int_l01)
                    str_HDat2 = tb_dt_DatBis(int_l01)
                    With .dgv_15_Beruf.Rows
                        .Add(tb_int_LFD(int_l01).ToString("##0"), str_HDat1, str_HDat2, tb_str_Beruf(int_l01))
                    End With
                Next
            End If
        End With

    End Sub

    REM ******************************************************
    REM *  Tabellenreiter Berufe                             *
    REM ******************************************************
    Public Shared Sub Mask_Out_16()
        With NM_Ahnen
            .rtx_16_1.Text = p_str_Memo
        End With
    End Sub

    Public Shared Sub Mask_Out_18()
        With NM_Ahnen

        End With
    End Sub

    REM ***************************************************************
    REM *  Anzeigen der Personendaten (Paten / Zeugen)                *
    REM ***************************************************************
    Public Shared Sub Mask_Out_17()
        With NM_Ahnen

            REM *----------------------------------------------------*
            REM *  Anzeige der Patendaten                            *
            REM *----------------------------------------------------*
            .dgv_17_Paten.Rows.Clear()
            If int_Pate >= 0 Then
                For int_l01 = 0 To int_Pate
                    r_lng_ID = tp_lng_ID(int_l01)
                    r_str_Name = tp_str_Name(int_l01)
                    r_str_GebName = tp_str_GebName(int_l01)
                    r_str_Vorname = tp_str_Vorname(int_l01)
                    r_str_GOrt = tp_str_GOrt(int_l01)
                    r_str_GDat_JJ = tp_str_GDat_JJ(int_l01)
                    r_str_GDat_MM = tp_str_GDat_MM(int_l01)
                    r_str_GDat_TT = tp_str_GDat_TT(int_l01)
                    r_str_SDat_JJ = tp_str_SDat_JJ(int_l01)
                    r_str_SDat_MM = tp_str_SDat_MM(int_l01)
                    r_str_SDat_TT = tp_str_SDat_TT(int_l01)
                    r_str_Geschl = tp_str_Geschl(int_l01)
                    Call Color_Geschlecht()
                    Call Erm_HDat()
                    REM *--------------------------------------------*
                    REM *  Füllen des DataGrids                      *
                    REM *--------------------------------------------*
                    With .dgv_17_Paten
                        .Rows.Add(r_lng_ID.ToString("###0"), r_str_Name, r_str_GebName, r_str_Vorname, str_HDat1, str_HDat2, str_HDat3)
                        .Rows(int_l01).DefaultCellStyle.ForeColor = col_tx_Geschl
                    End With
                Next
            End If
            REM *----------------------------------------------------*
            REM *  Anzeige der Zeugendaten                           *
            REM *----------------------------------------------------*
            .dgv_17_Zeugen.Rows.Clear()
            If int_Zeuge >= 0 Then
                For int_l01 = 0 To int_Zeuge
                    r_lng_ID = tz_lng_ID(int_l01)
                    r_str_Name = tz_str_Name(int_l01)
                    r_str_GebName = tz_str_GebName(int_l01)
                    r_str_Vorname = tz_str_Vorname(int_l01)
                    r_str_GOrt = tz_str_GOrt(int_l01)
                    r_str_GDat_JJ = tz_str_GDat_JJ(int_l01)
                    r_str_GDat_MM = tz_str_GDat_MM(int_l01)
                    r_str_GDat_TT = tz_str_GDat_TT(int_l01)
                    r_str_SDat_JJ = tz_str_SDat_JJ(int_l01)
                    r_str_SDat_MM = tz_str_SDat_MM(int_l01)
                    r_str_SDat_TT = tz_str_SDat_TT(int_l01)
                    r_str_Geschl = tz_str_Geschl(int_l01)
                    Call Color_Geschlecht()
                    Call Erm_HDat()
                    REM *--------------------------------------------*
                    REM *  Füllen des DataGrids                      *
                    REM *--------------------------------------------*
                    With .dgv_17_Zeugen
                        .Rows.Add(r_lng_ID.ToString("###0"), r_str_Name, r_str_GebName, r_str_Vorname, str_HDat1, str_HDat2, str_HDat3)
                        .Rows(int_l01).DefaultCellStyle.ForeColor = col_tx_Geschl
                    End With

                Next
            End If
        End With
    End Sub

    Public Shared Sub Mask_Out_Komm()
        REM *----------------------------------------------------*
        REM *  Prüfen auf Kommentarinfo,                         *
        REM *  wenn ja, dann Buttonfarbe ändern                  *
        REM *----------------------------------------------------*
        With NM_Ahnen
            If p_str_Komm_Name = "1" Then .bt_10_01_Name.BackColor = col_info2
            If p_str_Komm_GebName = "1" Then .bt_10_02_GebName.BackColor = col_info2
            If p_str_Komm_NameZ = "1" Then .bt_10_03_NameZ.BackColor = col_info2
            If p_str_Komm_Vorname = "1" Then .bt_10_04_Vorname.BackColor = col_info2
            If p_str_Komm_Rufname = "1" Then .bt_10_05_Rufname.BackColor = col_info2
            If p_str_Komm_SpitzN = "1" Then .bt_10_06_Spitzn.BackColor = col_info2
            If p_str_Komm_Titel = "1" Then .bt_10_07_Titel.BackColor = col_info2
            If p_str_Komm_GDat = "1" Then .bt_10_08_GDat.BackColor = col_info2
            If p_str_Komm_GOrt = "1" Then .bt_10_09_Geb.BackColor = col_info2
            If p_str_Komm_Geb1 = "1" Then .bt_10_10_GUrk.BackColor = col_info2
            If p_str_Komm_Geb2 = "1" Then .bt_10_11_Gurk2.BackColor = col_info2
            If p_str_Komm_SOrt = "1" Then .bt_10_12_SDat.BackColor = col_info2
            If p_str_Komm_SDat = "1" Then .bt_10_13_Sterb.BackColor = col_info2
            If p_str_Komm_Sterb1 = "1" Then .bt_10_14_SUrk.BackColor = col_info2
            If p_str_Komm_Sterb2 = "1" Then .bt_10_15_SUrk2.BackColor = col_info2
            If p_str_Komm_TDat = "1" Then .bt_11_01_Tauf_Dat.BackColor = col_info2
            If p_str_Komm_TOrt = "1" Then .bt_11_02_Tauf_Ort.BackColor = col_info2
            If p_str_Komm_TKirch = "1" Then .bt_11_03_Tauf_Kirche.BackColor = col_info2
            If p_str_Komm_TKonf = "1" Then .bt_11_04_Konf.BackColor = col_info2
            If p_str_Komm_TPriester = "1" Then .bt_11_05_Priester.BackColor = col_info2
            If p_str_Komm_TUrk = "1" Then .bt_11_06_Tauf_Urk.BackColor = col_info2
            If p_str_Komm_FDat = "1" Then .bt_11_08_FDat.BackColor = col_info2
            If p_str_Komm_FOrt = "1" Then .bt_11_09_FOrt.BackColor = col_info2
            If p_str_Komm_FKirche = "1" Then .bt_11_10_FKirche.BackColor = col_info2
            If p_str_Komm_FPriester = "1" Then .bt_11_11_FPriester.BackColor = col_info2
            If p_str_Komm_FUrk = "1" Then .bt_11_12_FUrk.BackColor = col_info2
            If p_str_Komm_BDat = "1" Then .bt_12_01_BDat.BackColor = col_info2
            If p_str_Komm_BOrt = "1" Then .bt_12_02_BOrt.BackColor = col_info2
            If p_str_Komm_BArt = "1" Then .bt_12_03_Bart.BackColor = col_info2
            If p_str_Komm_BPriester = "1" Then .bt_12_09_Priester.BackColor = col_info2
            If p_str_Komm_Friedhof = "1" Then .bt_12_04_Friedhof.BackColor = col_info2
            If p_str_Komm_Grablage = "1" Then .bt_12_05_Grablage.BackColor = col_info2
            If p_str_Komm_TodUrsache = "1" Then .bt_12_06_TodUr.BackColor = col_info2
            If p_str_Komm_BUrk1 = "1" Then .bt_12_07_StUrk.BackColor = col_info2
            If p_str_Komm_BUrk2 = "1" Then .bt_12_08_StUrk2.BackColor = col_info2
            If p_str_Komm_EDat1 = "1" Then .bt_13_01_Dat1.BackColor = col_info2
            If p_str_Komm_EOrt1 = "1" Then .bt_13_02_Ort1.BackColor = col_info2
            If p_str_Komm_EBeamt = "1" Then .bt_13_03_Beamter.BackColor = col_info2
            If p_str_Komm_EUrk1 = "1" Then .bt_13_04_Urk1.BackColor = col_info2
            'If p_str_Komm_ETZ1 = "1" Then .bt_13_05_TZ1.BackColor = col_info2
            If p_str_Komm_EDat2 = "1" Then .bt_13_06_Dat2.BackColor = col_info2
            If p_str_Komm_EOrt2 = "1" Then .bt_13_07_Ort2.BackColor = col_info2
            If p_str_Komm_EKirche = "1" Then .bt_13_08_Kirche.BackColor = col_info2
            If p_str_Komm_EPriester = "1" Then .bt_13_09_Priester.BackColor = col_info2
            If p_str_Komm_EUrk2 = "1" Then .bt_13_10_Urk2.BackColor = col_info2
            'If p_str_Komm_ETZ2 = "1" Then .bt_13_11_TZ2.BackColor = col_info2
            If p_str_Komm_EDat3 = "1" Then .bt_13_12_Dat3.BackColor = col_info2
            If p_str_Komm_EUrk3 = "1" Then .bt_13_13_Urk3.BackColor = col_info2
            .bt_10_01_Name.Image = NM_Info_No : If p_str_Komm_Name = "1" Then .bt_10_01_Name.Image = NM_Info_Yes
            .bt_10_02_GebName.Image = NM_Info_No : If p_str_Komm_GebName = "1" Then .bt_10_02_GebName.Image = NM_Info_Yes
            .bt_10_03_NameZ.Image = NM_Info_No : If p_str_Komm_NameZ = "1" Then .bt_10_03_NameZ.Image = NM_Info_Yes
            .bt_10_04_Vorname.Image = NM_Info_No : If p_str_Komm_Vorname = "1" Then .bt_10_04_Vorname.Image = NM_Info_Yes
            .bt_10_05_Rufname.Image = NM_Info_No : If p_str_Komm_Rufname = "1" Then .bt_10_05_Rufname.Image = NM_Info_Yes
            .bt_10_06_Spitzn.Image = NM_Info_No : If p_str_Komm_SpitzN = "1" Then .bt_10_06_Spitzn.Image = NM_Info_Yes
            .bt_10_07_Titel.Image = NM_Info_No : If p_str_Komm_Titel = "1" Then .bt_10_07_Titel.Image = NM_Info_Yes
            .bt_10_08_GDat.Image = NM_Info_No : If p_str_Komm_GDat = "1" Then .bt_10_08_GDat.Image = NM_Info_Yes
            .bt_10_09_Geb.Image = NM_Info_No : If p_str_Komm_GOrt = "1" Then .bt_10_09_Geb.Image = NM_Info_Yes
            .bt_10_10_GUrk.Image = NM_Info_No : If p_str_Komm_Vorname = "1" Then .bt_10_10_GUrk.Image = NM_Info_Yes
            .bt_10_11_Gurk2.Image = NM_Info_No : If p_str_Komm_Geb1 = "1" Then .bt_10_11_Gurk2.Image = NM_Info_Yes
            .bt_10_12_SDat.Image = NM_Info_No : If p_str_Komm_SDat = "1" Then .bt_10_12_SDat.Image = NM_Info_Yes
            .bt_10_13_Sterb.Image = NM_Info_No : If p_str_Komm_SOrt = "1" Then .bt_10_13_Sterb.Image = NM_Info_Yes
            .bt_10_14_SUrk.Image = NM_Info_No : If p_str_Komm_Sterb1 = "1" Then .bt_10_14_SUrk.Image = NM_Info_Yes
            .bt_10_15_SUrk2.Image = NM_Info_No : If p_str_Komm_Sterb2 = "1" Then .bt_10_15_SUrk2.Image = NM_Info_Yes
            .bt_11_01_Tauf_Dat.Image = NM_Info_No : If p_str_Komm_TDat = "1" Then .bt_11_01_Tauf_Dat.Image = NM_Info_Yes
            .bt_11_02_Tauf_Ort.Image = NM_Info_No : If p_str_Komm_TOrt = "1" Then .bt_11_02_Tauf_Ort.Image = NM_Info_Yes
            .bt_11_03_Tauf_Kirche.Image = NM_Info_No : If p_str_Komm_TKirch = "1" Then .bt_11_03_Tauf_Kirche.Image = NM_Info_Yes
            .bt_11_04_Konf.Image = NM_Info_No : If p_str_Komm_TKonf = "1" Then .bt_11_04_Konf.Image = NM_Info_Yes
            .bt_11_05_Priester.Image = NM_Info_No : If p_str_Komm_TPriester = "1" Then .bt_11_05_Priester.Image = NM_Info_Yes
            .bt_11_06_Tauf_Urk.Image = NM_Info_No : If p_str_Komm_TUrk = "1" Then .bt_11_06_Tauf_Urk.Image = NM_Info_Yes
            '.bt_11_07_TaufPaten.Image = NM_Info_No : If p_str_Komm_TPaten = "1" Then .bt_11_07_TaufPaten.Image = NM_Info_Yes
            .bt_11_08_FDat.Image = NM_Info_No : If p_str_Komm_FDat = "1" Then .bt_11_08_FDat.Image = NM_Info_Yes
            .bt_11_09_FOrt.Image = NM_Info_No : If p_str_Komm_FOrt = "1" Then .bt_11_09_FOrt.Image = NM_Info_Yes
            .bt_11_10_FKirche.Image = NM_Info_No : If p_str_Komm_FKirche = "1" Then .bt_11_10_FKirche.Image = NM_Info_Yes
            .bt_11_11_FPriester.Image = NM_Info_No : If p_str_Komm_FPriester = "1" Then .bt_11_11_FPriester.Image = NM_Info_Yes
            .bt_11_12_FUrk.Image = NM_Info_No : If p_str_Komm_FUrk = "1" Then .bt_11_12_FUrk.Image = NM_Info_Yes
            .bt_12_01_BDat.Image = NM_Info_No : If p_str_Komm_BDat = "1" Then .bt_12_01_BDat.Image = NM_Info_Yes
            .bt_12_02_BOrt.Image = NM_Info_No : If p_str_Komm_BOrt = "1" Then .bt_12_02_BOrt.Image = NM_Info_Yes
            .bt_12_03_Bart.Image = NM_Info_No : If p_str_Komm_BArt = "1" Then .bt_12_03_Bart.Image = NM_Info_Yes
            .bt_12_09_Priester.Image = NM_Info_No : If p_str_Komm_BPriester = "1" Then .bt_12_09_Priester.Image = NM_Info_Yes
            .bt_12_04_Friedhof.Image = NM_Info_No : If p_str_Komm_Friedhof = "1" Then .bt_12_04_Friedhof.Image = NM_Info_Yes
            .bt_12_05_Grablage.Image = NM_Info_No : If p_str_Komm_Grablage = "1" Then .bt_12_05_Grablage.Image = NM_Info_Yes
            .bt_12_06_TodUr.Image = NM_Info_No : If p_str_Komm_TodUrsache = "1" Then .bt_12_06_TodUr.Image = NM_Info_Yes
            .bt_12_07_StUrk.Image = NM_Info_No : If p_str_Komm_BUrk1 = "1" Then .bt_12_07_StUrk.Image = NM_Info_Yes
            .bt_12_08_StUrk2.Image = NM_Info_No : If p_str_Komm_BUrk2 = "1" Then .bt_12_08_StUrk2.Image = NM_Info_Yes
            .bt_13_01_Dat1.Image = NM_Info_No : If p_str_Komm_EDat1 = "1" Then .bt_13_01_Dat1.Image = NM_Info_Yes
            .bt_13_02_Ort1.Image = NM_Info_No : If p_str_Komm_EOrt1 = "1" Then .bt_13_02_Ort1.Image = NM_Info_Yes
            .bt_13_03_Beamter.Image = NM_Info_No : If p_str_Komm_EBeamt = "1" Then .bt_13_03_Beamter.Image = NM_Info_Yes
            .bt_13_04_Urk1.Image = NM_Info_No : If p_str_Komm_EUrk1 = "1" Then .bt_13_04_Urk1.Image = NM_Info_Yes
            '.bt_13_05_TZ1.Image = NM_Info_No : If p_str_Komm_ETZ1 = "1" Then .bt_13_05_TZ1.Image = NM_Info_Yes
            .bt_13_06_Dat2.Image = NM_Info_No : If p_str_Komm_EDat2 = "1" Then .bt_13_06_Dat2.Image = NM_Info_Yes
            .bt_13_07_Ort2.Image = NM_Info_No : If p_str_Komm_EOrt2 = "1" Then .bt_13_07_Ort2.Image = NM_Info_Yes
            .bt_13_08_Kirche.Image = NM_Info_No : If p_str_Komm_EKirche = "1" Then .bt_13_08_Kirche.Image = NM_Info_Yes
            .bt_13_09_Priester.Image = NM_Info_No : If p_str_Komm_EPriester = "1" Then .bt_13_09_Priester.Image = NM_Info_Yes
            .bt_13_10_Urk2.Image = NM_Info_No : If p_str_Komm_EUrk2 = "1" Then .bt_13_10_Urk2.Image = NM_Info_Yes
            '.bt_13_11_TZ2.Image = NM_Info_No : If p_str_Komm_ETZ2 = "1" Then .bt_13_11_TZ2.Image = NM_Info_Yes
            .bt_13_12_Dat3.Image = NM_Info_No : If p_str_Komm_EDat3 = "1" Then .bt_13_12_Dat3.Image = NM_Info_Yes
            .bt_13_13_Urk3.Image = NM_Info_No : If p_str_Komm_EUrk3 = "1" Then .bt_13_13_Urk3.Image = NM_Info_Yes
        End With
    End Sub

    REM *************************************************************
    REM *  Anzeige der Ehedaten (linke Seite)                       *
    REM *************************************************************
    Public Shared Sub Mask_Out_Grid_Ehe()
        With NM_Ahnen
            .lby_13_Partner.Items.Clear()
            .dgv_Ehen.Rows.Clear()
            ReDim str_EFeld(int_Ehe)
            If int_Ehe >= 0 Then
                Call Mask_Out_Button_Ehe(True)
                For int_l01 = 0 To int_Ehe
                    r_lng_ID = te_lng_ID(int_l01)
                    r_str_Name = te_str_Name(int_l01)
                    r_str_GebName = te_str_GebName(int_l01)
                    r_str_Vorname = te_str_Vorname(int_l01)
                    r_str_GOrt = te_str_GOrt(int_l01)
                    r_str_GDat_JJ = te_str_GDat_JJ(int_l01)
                    r_str_GDat_MM = te_str_GDat_MM(int_l01)
                    r_str_GDat_TT = te_str_GDat_TT(int_l01)
                    r_str_SDat_JJ = te_str_SDat_JJ(int_l01)
                    r_str_SDat_MM = te_str_SDat_MM(int_l01)
                    r_str_SDat_TT = te_str_SDat_TT(int_l01)
                    r_str_SOrt = te_str_SOrt(int_l01)
                    r_str_Geschl = te_str_Geschl(int_l01)
                    Call Color_Geschlecht()
                    Call Mask_Out_HFeld()
                    str_EFeld(int_l01) = str_HFeld
                    Call Erm_HDat()
                    REM *--------------------------------------------*
                    REM *  Füllen des DataGrids                      *
                    REM *--------------------------------------------*
                    With .dgv_Ehen
                        .Rows.Add(r_lng_ID.ToString("###0"), r_str_Name, r_str_GebName, r_str_Vorname, str_HDat1, str_HDat2, str_HDat3)
                        .Rows(int_l01).DefaultCellStyle.ForeColor = col_tx_Geschl
                    End With
                    .lby_13_Partner.Items.Add(str_HFeld)
                    REM *--------------------------------------------*
                    REM *  Füllen des Tabellenreiters                *
                    REM *--------------------------------------------*
                    If int_l01 = 0 Then
                        .tx_13_Partner.Text = r_lng_ID.ToString
                        .lbx_15_Partner.Text = str_EFeld(int_l01)
                        p_int_Ehe41 = r_lng_ID
                        Call Person_Read_EheDaten()
                        Call Mask_Out_Ehe()
                    End If
                Next
            Else
                .tx_13_Partner.Text = ""
                .lbx_15_Partner.Text = ""
                Call Mask_Out_Button_Ehe(False)
            End If
        End With
        Call Mask_Out_Komm_Ehe()
    End Sub

    Public Shared Sub Mask_Out_Komm_Ehe()
        REM *----------------------------------------------------*
        REM *  Prüfen auf Kommentarinfo,                         *
        REM *  wenn ja, dann Buttonfarbe ändern                  *
        REM *----------------------------------------------------*
        With NM_Ahnen
            If p_str_Komm_EDat1 = "1" Then .bt_13_01_Dat1.BackColor = col_info2
            If p_str_Komm_EOrt1 = "1" Then .bt_13_02_Ort1.BackColor = col_info2
            If p_str_Komm_EBeamt = "1" Then .bt_13_03_Beamter.BackColor = col_info2
            If p_str_Komm_EUrk1 = "1" Then .bt_13_04_Urk1.BackColor = col_info2
            'If p_str_Komm_ETZ1 = "1" Then .bt_13_05_TZ1.BackColor = col_info2
            If p_str_Komm_EDat2 = "1" Then .bt_13_06_Dat2.BackColor = col_info2
            If p_str_Komm_EOrt2 = "1" Then .bt_13_07_Ort2.BackColor = col_info2
            If p_str_Komm_EKirche = "1" Then .bt_13_08_Kirche.BackColor = col_info2
            If p_str_Komm_EPriester = "1" Then .bt_13_09_Priester.BackColor = col_info2
            If p_str_Komm_EUrk2 = "1" Then .bt_13_10_Urk2.BackColor = col_info2
            'If p_str_Komm_ETZ2 = "1" Then .bt_13_11_TZ2.BackColor = col_info2
            If p_str_Komm_EDat3 = "1" Then .bt_13_12_Dat3.BackColor = col_info2
            If p_str_Komm_EUrk3 = "1" Then .bt_13_13_Urk3.BackColor = col_info2
        End With
    End Sub


    REM **************************************************************
    REM *  Info-Schalter nicht sichtbar, wenn Daten vorhanden        *
    REM **************************************************************
    Public Shared Sub Mask_Out_Button_Ehe(ByVal btn_Vis As Boolean)
        With NM_Ahnen
            .bt_13_01_Dat1.Visible = btn_Vis
            .bt_13_02_Ort1.Visible = btn_Vis
            .bt_13_03_Beamter.Visible = btn_Vis
            .bt_13_04_Urk1.Visible = btn_Vis
            .bt_13_05_TZ1.Visible = btn_Vis
            .bt_13_06_Dat2.Visible = btn_Vis
            .bt_13_07_Ort2.Visible = btn_Vis
            .bt_13_08_Kirche.Visible = btn_Vis
            .bt_13_09_Priester.Visible = btn_Vis
            .bt_13_10_Urk2.Visible = btn_Vis
            .bt_13_11_TZ2.Visible = btn_Vis
            .bt_13_12_Dat3.Visible = btn_Vis
            .bt_13_13_Urk3.Visible = btn_Vis
        End With
    End Sub

    REM *************************************************************
    REM *  Anzeige der Geschwisterdaten                             *
    REM *************************************************************
    Public Shared Sub Mask_Out_Grid_Geschwister()
        With NM_Ahnen.dgv_Geschwister
            .Rows.Clear()
            If int_Ges > -1 Then
                For int_l01 = 0 To int_Ges
                    r_lng_ID = tg_lng_ID(int_l01)
                    r_str_Name = tg_str_Name(int_l01)
                    r_str_GebName = tg_str_GebName(int_l01)
                    r_str_Vorname = tg_str_Vorname(int_l01)
                    r_str_GOrt = tg_str_GOrt(int_l01)
                    r_str_GDat_JJ = tg_str_GDat_JJ(int_l01)
                    r_str_GDat_MM = tg_str_GDat_MM(int_l01)
                    r_str_GDat_TT = tg_str_GDat_TT(int_l01)
                    r_str_SDat_JJ = tg_str_SDat_JJ(int_l01)
                    r_str_SDat_MM = tg_str_SDat_MM(int_l01)
                    r_str_SDat_TT = tg_str_SDat_TT(int_l01)
                    r_str_Geschl = tg_str_Geschl(int_l01)
                    Call Color_Geschlecht()
                    Call Erm_HDat()
                    REM *--------------------------------------------*
                    REM *  Füllen des DataGrids                      *
                    REM * -------------------------------------------*
                    .RowsDefaultCellStyle.ForeColor = col_tx_Geschl
                    .Rows.Add(r_lng_ID.ToString("####0"), r_str_Name, r_str_GebName, r_str_Vorname, str_HDat1, str_HDat2, str_HDat3, r_str_Geschl)
                    .Rows(int_l01).DefaultCellStyle.ForeColor = col_tx_Geschl
                    ' For Each Zeile As DataGridViewRow In .Rows
                    'If Zeile.Cells.Item(7).Value = "F" Then
                    'Zeile.Cells.Item(1).Style.ForeColor = col_tx_Frau
                    'Else
                    'Zeile.Cells.Item(1).Style.ForeColor = col_tx_Mann
                    'End If
                    'Next
                Next
            End If
            .Sort(NM_Ahnen.dgv_Geschwister.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
        End With
        NM_Ahnen.dgv_Geschwister.Sort(NM_Ahnen.dgv_Geschwister.Columns(6), System.ComponentModel.ListSortDirection.Ascending)
        With NM_Ahnen.dgv_Geschwister
            For int_l01 = 0 To int_Ges
                r_str_Geschl = .Rows(int_l01).Cells(7).Value
                Call Color_Geschlecht()
                For l02 = 0 To 6
                    .Rows(int_l01).Cells(l02).Style.ForeColor = col_tx_Geschl
                Next
            Next
        End With

        'With NM_Ahnen.dgv_Geschwister
        'For int_l01 = 0 To int_Ges
        'r_str_Geschl = .Rows(int_l01).Cells(7).Value
        'Call Color_Geschlecht()
        'For l02 = 0 To 6
        '.Rows(int_l01).Cells(l02).Style.ForeColor = col_tx_Geschl
        'Next
        'Next
        'End With
    End Sub

    REM *************************************************************
    REM *  Anzeige der Kinderdaten                                  *
    REM *************************************************************
    Public Shared Sub Mask_Out_Grid_Kinder()
        With NM_Ahnen.dgv_Kinder
            .Rows.Clear()
            If int_Kind >= 0 Then
                For int_l01 = 0 To int_Kind
                    r_lng_ID = tk_lng_ID(int_l01)
                    r_str_Name = tk_str_Name(int_l01)
                    r_str_GebName = tk_str_GebName(int_l01)
                    r_str_Vorname = tk_str_Vorname(int_l01)
                    r_str_GOrt = tk_str_GOrt(int_l01)
                    r_str_GDat_JJ = tk_str_GDat_JJ(int_l01)
                    r_str_GDat_MM = tk_str_GDat_MM(int_l01)
                    r_str_GDat_TT = tk_str_GDat_TT(int_l01)
                    r_str_SDat_JJ = tk_str_SDat_JJ(int_l01)
                    r_str_SDat_MM = tk_str_SDat_MM(int_l01)
                    r_str_SDat_TT = tk_str_SDat_TT(int_l01)
                    r_str_Geschl = tk_str_Geschl(int_l01)
                    Call Color_Geschlecht()
                    Call Erm_HDat()
                    REM *--------------------------------------------*
                    REM *  Füllen des DataGrids                      *
                    REM *--------------------------------------------*
                    .Rows.Add(r_lng_ID.ToString("###0"), r_str_Name, r_str_GebName, r_str_Vorname, str_HDat1, str_HDat2, str_HDat3)
                    .Rows(int_l01).DefaultCellStyle.ForeColor = col_tx_Geschl
                Next
            End If
        End With
    End Sub

    REM *************************************************************
    REM *  Ermitteln Hilfsdatenfelder für Grid-Anzeige              *
    REM *************************************************************
    Public Shared Sub Erm_HDat()
        'If r_str_Name = r_str_GebName Then r_str_GebName = ""
        str_HDat1 = ""
        str_HDat2 = ""
        str_HDat3 = ""
        If r_str_GDat_TT > "  " Or r_str_GDat_MM > "  " Or r_str_GDat_JJ > "    " Then
            str_HDat1 = r_str_GDat_TT + "." + r_str_GDat_MM + "." + r_str_GDat_JJ
            str_HDat3 = r_str_GDat_JJ + "." + r_str_GDat_MM + "." + r_str_GDat_TT
        End If
        If r_str_SDat_TT > "  " Or r_str_SDat_MM > "  " Or r_str_SDat_JJ > "    " Then
            str_HDat2 = r_str_SDat_TT + "." + r_str_SDat_MM + "." + r_str_SDat_JJ
        End If
    End Sub

    REM **************************************************************
    REM *  Anzeige der Ehedaten                                      *
    REM **************************************************************
    Public Shared Sub Mask_Out_Ehe()
        With NM_Ahnen
            .tx_13_Dat1_TT.Text = p_str_EDat1_TT
            .tx_13_Dat1_MM.Text = p_str_EDat1_MM
            .tx_13_Dat1_JJ.Text = p_str_EDat1_JJ
            If p_str_EDat1_TT = "" And p_str_EDat1_MM = "" And p_str_EDat1_JJ = "" Then p_int_EDat1_Art = 0
            .cbx_13_EDat1_Art.Text = str_Para_DA(p_int_EDat1_Art)
            .tx_13_Dat2_TT.Text = p_str_EDat2_TT
            .tx_13_Dat2_MM.Text = p_str_EDat2_MM
            .tx_13_Dat2_JJ.Text = p_str_Edat2_JJ
            If p_str_EDat2_TT = "" And p_str_EDat2_MM = "" And p_str_Edat2_JJ = "" Then p_int_EDat2_Art = 0
            .cbx_13_EDat2_Art.Text = str_Para_DA(p_int_EDat2_Art)
            .tx_13_Dat3_TT.Text = p_str_EDat3_TT
            .tx_13_Dat3_MM.Text = p_str_EDat3_MM
            .tx_13_Dat3_JJ.Text = p_str_EDat3_JJ
            If p_str_EDat3_TT = "" And p_str_EDat3_MM = "" And p_str_EDat3_JJ = "" Then p_int_EDat3_Art = 0
            .cbx_13_EDat3_Art.Text = str_Para_DA(p_int_EDat3_Art)
            .tx_13_Ort1.Text = p_str_EOrt1
            .tx_13_Ort2.Text = p_str_EOrt2
            .lbl_13_IUrk1.Text = p_str_Quelle(10)
            .lbl_13_IUrk2.Text = p_str_Quelle(9)
            .lbl_13_IUrk3.Text = p_str_Quelle(11)
            .tx_13_Beamter.Text = p_str_EBeamter
            .tx_13_Priester.Text = p_str_EPriester
            .tx_13_Kirche.Text = p_str_EKirche
        End With
    End Sub

    REM **************************************************************
    REM *  Aufbereiten der Feldes str_HFeld für Listbox              *
    REM **************************************************************
    Public Shared Sub Mask_Out_HFeld()

        If r_str_Name = r_str_GebName Then r_str_GebName = ""
        str_HFeld = ""
        str_HFeld = r_lng_ID.ToString("###0") + "  " + r_str_Name
        If r_str_GebName > "" Then str_HFeld = str_HFeld + ", " + r_str_GebName
        If r_str_Vorname > "" Then str_HFeld = str_HFeld + ", " + r_str_Vorname
        If r_str_GDat_JJ > "" Or r_str_GDat_MM > "" Or r_str_GDat_TT > "" Then
            str_HFeld = str_HFeld + ", * " + r_str_GDat_TT + "." + r_str_GDat_MM + "." + r_str_GDat_JJ
        End If
        If r_str_GOrt > "" Then str_HFeld = str_HFeld + ", " + r_str_GOrt
        If r_str_SDat_JJ > "" Or r_str_SDat_MM > "" Or r_str_SDat_TT > "" Then
            str_HFeld = str_HFeld + ", + " + r_str_SDat_TT + "." + r_str_SDat_MM + "." + r_str_SDat_JJ
        End If
        If r_str_SOrt > "" Then str_HFeld = str_HFeld + ", " + r_str_SOrt
    End Sub

    REM **************************************************************
    REM *  Löschen aller Textfelder in den Masken                    *
    REM **************************************************************
    Public Shared Sub Mask_Clear()
        int_Merk_Tab_Anschr = 0
        int_Merk_Tab_Beerd = 0
        int_Merk_Tab_Beruf = 0
        int_Merk_Tab_Ehe = 0
        int_Merk_Tab_Paten = 0
        int_Merk_Tab_Taufe = 0
        int_Merk_Tab_Text = 0
        With NM_Ahnen
            .lbx_01_Vater1.Text = ""
            .lbx_01_Vater2.Text = ""
            .lbx_01_Mutter1.Text = ""
            .lbx_01_Mutter2.Text = ""
        End With
        p_int_ID = 0
        p_int_Mutter = 0
        p_int_Vater = 0
        p_str_Name = ""
        p_str_GebName = ""
        p_str_NameZ = ""
        p_str_Vorname = ""
        p_str_Rufname = ""
        p_str_SpitzN = ""
        p_str_Titel = ""
        p_str_Geschl = ""
        p_str_Konf = ""
        p_str_GDat_TT = ""
        p_str_GDat_MM = ""
        p_str_GDat_JJ = ""
        p_int_GArt = 0
        p_str_GOrt = ""
        p_str_GUrk = ""
        p_str_SDat_TT = ""
        p_str_SDat_MM = ""
        p_str_SDat_JJ = ""
        p_int_SArt = 0
        p_str_SOrt = ""
        p_str_SUrk = ""
        p_str_TDat_TT = ""
        p_str_TDat_MM = ""
        p_str_TDat_JJ = ""
        p_int_TDat_Art = 0
        p_str_TOrt = ""
        p_str_TKirche = ""
        p_str_TUrk = ""
        p_str_TPriester = ""
        p_str_FDat_TT = ""
        p_str_FDat_MM = ""
        p_str_FDat_JJ = ""
        p_int_FDat_Art = 0
        p_str_FOrt = ""
        p_str_FKirche = ""
        p_str_FUrk = ""
        p_str_FPriester = ""
        p_str_TBemerk = ""
        p_str_BDat_TT = ""
        p_str_BDat_MM = ""
        p_str_BDat_JJ = ""
        p_int_BDat_Art = 0
        p_str_BOrt = ""
        p_str_Friedhof = ""
        p_str_BPriester = ""
        p_str_Grablage = ""
        p_str_BUrk1 = ""
        p_str_BUrk2 = ""
        p_str_BArt = ""
        p_str_TodUrsache = ""
        p_str_BBemerk = ""
        For int_i09 = 0 To 12
            p_str_Quelle(int_i09) = ""
        Next
        Call Mask_Clear_Komm()
        Call Mask_Clear_Ehe()
    End Sub

    REM **************************************************************
    REM *  Löschen der Speicherfelder für Kommentare                 *
    REM **************************************************************
    Public Shared Sub Mask_Clear_Komm()
        p_str_Komm_Name = "0"
        p_str_Komm_NameZ = "0"
        p_str_Komm_GebName = "0"
        p_str_Komm_Vorname = "0"
        p_str_Komm_Rufname = "0"
        p_str_Komm_SpitzN = "0"
        p_str_Komm_GDat = "0"
        p_str_Komm_GOrt = "0"
        p_str_Komm_Geb1 = "0"
        p_str_Komm_Geb2 = "0"
        p_str_Komm_SDat = "0"
        p_str_Komm_SOrt = "0"
        p_str_Komm_Sterb1 = "0"
        p_str_Komm_Sterb2 = "0"
        p_str_Komm_Titel = "0"
        p_str_Komm_TDat = "0"
        p_str_Komm_TOrt = "0"
        p_str_Komm_TKirch = "0"
        p_str_Komm_TPriester = "0"
        p_str_Komm_TUrk = "0"
        'p_str_Komm_TPaten = "0"
        p_str_Komm_FDat = "0"
        p_str_Komm_FOrt = "0"
        p_str_Komm_FKirche = "0"
        p_str_Komm_FPriester = "0"
        p_str_Komm_FUrk = "0"
        With NM_Ahnen
            .bt_10_01_Name.BackColor = col_info1
            .bt_10_03_NameZ.BackColor = col_info1
            .bt_10_02_GebName.BackColor = col_info1
            .bt_10_04_Vorname.BackColor = col_info1
            .bt_10_05_Rufname.BackColor = col_info1
            .bt_10_06_Spitzn.BackColor = col_info1
            .bt_10_07_Titel.BackColor = col_info1
            .bt_10_08_GDat.BackColor = col_info1
            .bt_10_09_Geb.BackColor = col_info1
            .bt_10_10_GUrk.BackColor = col_info1
            .bt_10_11_Gurk2.BackColor = col_info1
            .bt_10_12_SDat.BackColor = col_info1
            .bt_10_13_Sterb.BackColor = col_info1
            .bt_10_14_SUrk.BackColor = col_info1
            .bt_10_15_SUrk2.BackColor = col_info1
            .bt_11_01_Tauf_Dat.BackColor = col_info1
            .bt_11_02_Tauf_Ort.BackColor = col_info1
            .bt_11_03_Tauf_Kirche.BackColor = col_info1
            .bt_11_04_Konf.BackColor = col_info1
            .bt_11_05_Priester.BackColor = col_info1
            .bt_11_06_Tauf_Urk.BackColor = col_info1
            .bt_11_07_TaufPaten.BackColor = col_info1
            .bt_11_08_FDat.BackColor = col_info1
            .bt_11_09_FOrt.BackColor = col_info1
            .bt_11_10_FKirche.BackColor = col_info1
            .bt_11_11_FPriester.BackColor = col_info1
            .bt_11_12_FUrk.BackColor = col_info1
            .bt_12_01_BDat.BackColor = col_info1
            .bt_12_02_BOrt.BackColor = col_info1
            .bt_12_03_Bart.BackColor = col_info1
            .bt_12_04_Friedhof.BackColor = col_info1
            .bt_12_05_Grablage.BackColor = col_info1
            .bt_12_06_TodUr.BackColor = col_info1
            .bt_12_07_StUrk.BackColor = col_info1
            .bt_12_08_StUrk2.BackColor = col_info1
            .bt_12_09_Priester.BackColor = col_info1
        End With
    End Sub

    REM **************************************************************
    REM *  Löschen der Maskenfelder und Hilfsfelder für Ehedaten     *
    REM **************************************************************
    Public Shared Sub Mask_Clear_Ehe()
        p_str_EBeamter = ""
        p_str_EDat1_JJ = ""
        p_str_EDat1_MM = ""
        p_str_EDat1_TT = ""
        p_str_Edat2_JJ = ""
        p_str_EDat2_MM = ""
        p_str_EDat2_TT = ""
        p_str_EDat3_JJ = ""
        p_str_EDat3_MM = ""
        p_str_EDat3_TT = ""
        p_int_EDat1_Art = 0
        p_int_EDat2_Art = 0
        p_int_EDat3_Art = 0
        p_str_EKirche = ""
        p_str_EPriester = ""
        p_str_EOrt1 = ""
        p_str_EOrt2 = ""
        p_str_EUrk1 = ""
        p_str_EUrk2 = ""
        p_str_EUrk3 = ""
        p_str_E_Bemerk = ""
        p_str_Komm_EDat1 = "0"
        p_str_Komm_EDat2 = "0"
        p_str_Komm_EDat3 = "0"
        p_str_Komm_EOrt1 = "0"
        p_str_Komm_EOrt2 = "0"
        p_str_Komm_EUrk1 = "0"
        p_str_Komm_EUrk2 = "0"
        p_str_Komm_EUrk3 = "0"
        p_str_Komm_EBeamt = "0"
        p_str_Komm_EKirche = "0"
        p_str_Komm_ETZ1 = "0"
        p_str_Komm_ETZ2 = "0"
        p_str_Komm_EPriester = "0"
        With NM_Ahnen
            .bt_13_01_Dat1.BackColor = col_info1
            .bt_13_02_Ort1.BackColor = col_info1
            .bt_13_03_Beamter.BackColor = col_info1
            .bt_13_04_Urk1.BackColor = col_info1
            '.bt_13_05_TZ1.BackColor = col_info1
            .bt_13_06_Dat2.BackColor = col_info1
            .bt_13_07_Ort2.BackColor = col_info1
            .bt_13_08_Kirche.BackColor = col_info1
            .bt_13_09_Priester.BackColor = col_info1
            .bt_13_10_Urk2.BackColor = col_info1
            '.bt_13_11_TZ2.BackColor = col_info1
            .bt_13_12_Dat3.BackColor = col_info1
            .bt_13_13_Urk3.BackColor = col_info1
        End With
        Call Mask_Out_Ehe()
    End Sub
    Public Shared Sub Color_Geschlecht()
        col_tx_Geschl = col_tx_Mann
        If r_str_Geschl = "F" Then col_tx_Geschl = col_tx_Frau
    End Sub
End Class
